#include <stdio.h>
#include <stdlib.h>
#include "align.h"
#include "clus.h"
#include "clusters.h"
#include "parells.h"
#include "multiple.h"
#include "auxiliar.h"

void reservar_memoria_alineament(int alf,int midaalf,int longmer,int revseq){
  int i,j;
  matpesos = (float **) malloc((++midaalf) * sizeof(float *));
  if (matpesos == NULL){printf("5:Out of memory\n");exit(-1);}
  i = 0;
  while (i < midaalf){
    matpesos[i] = (float *) malloc(midaalf * sizeof(float));
    if (matpesos[i] == NULL){printf("6:Out of memory\n");exit(-1);}
    i++;
  }
  midaalf--;
  //printf("reservo memoria per als clusters\n");
  clusters = (tscluster *) malloc(MAXNUMSEQS * sizeof(tscluster));
  if (clusters == NULL)     exit(-1);
  for(i = 0; i < MAXNUMSEQS; i++){
    clusters[i].nom_seq = (char *) malloc (MAXLONGNOM *sizeof(char));
    if (clusters[i].nom_seq == NULL){printf("1:Out of memory\n");exit(-1);}
    clusters[i].quines = (int *) malloc (MAXNUMSEQS * sizeof(int));
    if (clusters[i].quines == NULL){printf("2:Out of memory\n");exit(-1);}
    clusters[i].perfil = (tsinfo_cluster_columna *) malloc (MAXLONGSEQ * sizeof(tsinfo_cluster_columna));
    if (clusters[i].perfil == NULL){printf("3:Out of memory\n");exit(-1);}
    for (j=0;j<MAXLONGSEQ;j++){
      clusters[i].perfil[j].freq = (float *) malloc(midaalf*sizeof(float));
      if (clusters[i].perfil[j].freq == NULL){printf("4:Out of memory\n");exit(-1);}
    }
  }
 //reservo meoria per les sequencies
  matseqs = (int **) malloc((MAXNUMSEQS+1) * sizeof(int *));
  if (matseqs == NULL){printf("Out of memory of matseqs\n");exit(-1);}
  for (i = 0;i < MAXNUMSEQS;i++){
    matseqs[i] = (int *) malloc(MAXLONGSEQ * sizeof(int)); 
    if (matseqs[i] == NULL){printf("Out of memory matseqs[%d]\n",i);exit(-1);}
  }
 
  
  // reservo memoria matriu similaritat parells per no resrvar-la a cada crida
  matriu = (float **) malloc(MAXLONGSEQ * sizeof(float *));
  if (matriu == NULL){printf("7:Out of memory\n");exit(-1);}
  for(i = 0;i < MAXLONGSEQ;i++){
    matriu[i] = (float *) malloc(MAXLONGSEQ * sizeof(float));
    if (matriu[i] == NULL){printf("8Out of memory\n");exit(-1);}
  }
  //reservo espai matriu puntuacions, cami, matriu_permutacions i matriu_intra_cluster
  matriu_puntuacions = (float **) malloc(MAXNUMSEQS * sizeof(float *));
  if (matriu_puntuacions == NULL){printf("9Out of memory\n");exit(-1);}
  for(i = 0;i < MAXNUMSEQS;i++){
    matriu_puntuacions[i] = (float *) malloc(MAXNUMSEQS * sizeof(float));
    if (matriu_puntuacions[i] == NULL){printf("10:Out of memory\n");exit(-1);}
  }
  matriu_permutacions = (int **) malloc(MAXNUMSEQS * sizeof(int *));
  if (matriu_permutacions == NULL){printf("9Out of memory\n");exit(-1);}
  for(i = 0;i < MAXNUMSEQS;i++){
    matriu_permutacions[i] = (int *) malloc(MAXNUMSEQS * sizeof(int));
    if (matriu_permutacions[i] == NULL){printf("10:Out of memory\n");exit(-1);}
  }
  matriu_cami = (char **) malloc(MAXLONGSEQ * sizeof(char *));
  if (matriu_cami == NULL){printf("11:Out of memory\n");exit(-1);}
  for(i = 0;i < MAXLONGSEQ;i++){
    matriu_cami[i] = (char *) malloc(MAXLONGSEQ * sizeof(char));
    if (matriu_cami[i] == NULL){printf("12:Out of memory\n");exit(-1);}
  }
  matriu_intra_cluster = (float **) malloc(MAXLONGSEQ * sizeof(float *));
  if (matriu_intra_cluster == NULL){printf("15:Out of memory\n");exit(-1);}
  for(i = 0;i < MAXLONGSEQ;i++){
    matriu_intra_cluster[i] = (float *) malloc(MAXLONGSEQ * sizeof(float));
    if (matriu_intra_cluster[i] == NULL){printf("16:Out of memory\n");exit(-1);}
  }
  //memoria per a les crides
  seq1 = (int *) malloc (MAXLONGSEQ *sizeof(int));
  if (seq1 == NULL){printf("Out of memory seq1:align\n");exit(-1);}
  seq2 = (int *) malloc (MAXLONGSEQ *sizeof(int));
  if (seq2 == NULL){printf("Out of memory seq2:align\n");exit(-1);}

  resultat_cluster1 = (char *) malloc (MAXLONGALIN *sizeof(char));
  if (resultat_cluster1 == NULL){printf("Out of memory resultat_cluster1:align\n");exit(-1);}
  resultat_cluster2 = (char *) malloc (MAXLONGALIN *sizeof(char));
  if (resultat_cluster2 == NULL){printf("Out of memory resultat_cluster2:align\n");exit(-1);}
  seq = (int *)malloc(MAXLONGSEQ * sizeof(int ));
  if (seq == NULL){printf("12:Out of memory\n");exit(-1);}
  //Vector que cont la posicio de les seqencies semi-aliniades
  pos_seq = (long *)malloc(MAXNUMSEQS * sizeof(long));
  if (pos_seq == NULL) {printf("13:Memory KO"); exit(-1);}
  for(i = 0; i < MAXNUMSEQS; i++)pos_seq[i] = -1;
  
  //Vector que cont a quin cluster pertany cada seqencia
  seq_cluster = (int *)malloc(MAXNUMSEQS * sizeof(int));
  if (seq_cluster == NULL) {printf("14:Memory KO"); exit(-1);}
  for(i = 0; i < MAXNUMSEQS; i++) seq_cluster[i] = i;

 //Vector que cont les equivalncies entre clusters
  cluster_equivalent = (int *)malloc(MAXNUMSEQS * sizeof(int));
  if (cluster_equivalent == NULL){printf("align:cluster_equivalent"); exit(-1);}
  
  /* per indicar l'esquema i la puntuacio de la 'alineament entre els clusters*/
  resultat_cluster1 = (char *)malloc(MAXLONGSEQ * sizeof(char));
  if (resultat_cluster1 == NULL){printf("16:Memory KO"); exit(-1);}
  resultat_cluster2 = (char *)malloc(MAXLONGSEQ * sizeof(char));
  if (resultat_cluster2 == NULL){printf("17:Memory KO"); exit(-1);}




}

void align(int numseqs,int alf, int infoalign, int colnomsort,float ** matpesos,int esc_concensus,int esc_alin,int numrepeats)
{
  FILE *fentrada; 
  int midaalf,longmer,colsnom,permutcirculars,metodecalculsim,alinparcial;
  int minnumseqs,guardarsim,tipusconcensus,revseq;
  int permut;
  float llindaralin;
  int longseq1,longseq2;
  float res;
  int i,j,k,l,s1,s2;
  int aleat;//numero aleatori pels fitxers auxiliars
   
  longmer=1;
  revseq=0;
  permutcirculars=0;
  metodecalculsim=1;
  guardarsim=0;
  alinparcial=0;
  minnumseqs=1;
  tipusconcensus=0;
  switch (alf){
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
  }
  if (numseqs>MAXNUMSEQS)
    printf("Hi ha massa sequencies\n");
  //else printf("Number of sequences=%d\n",numseqs);
  
  //llegir_clusters(nomfentrada,numseqs,alf,midaalf,longmer,revseq);  
  calcul_sim_per_parelles(numseqs,revseq,permutcirculars,metodecalculsim,matpesos,alf);
  alineament_multiple(clusters,infoalign,colsnom,alinparcial,llindaralin,minnumseqs,metodecalculsim,tipusconcensus,alf,matpesos,numseqs,longmer,revseq,esc_concensus,esc_alin,numrepeats);
}


