#include <ctype.h>
#include "clus.h"
#include "auxiliar.h"

//Implementaci de les funcions

/* comptar sequencies de fitxer: compto els > *******************/
int comptar_sequencies(char *nomfitxerentrada){
  char c;
  int n=0;
  FILE *fentrada;

  if(!(fentrada = fopen(nomfitxerentrada,"r"))){
    printf("error: opening sequences file \n");
    exit(-1);
  }
  //printf("fitxer entrada=%s\n",nomfitxerentrada);
  c=fgetc(fentrada);
  while (!(feof(fentrada))){
    if (c=='>') n++;
    c=fgetc(fentrada);
  }
  fclose(fentrada);
  return n;
}
  
/* metodecalculsim1 **********************************************************/
//divideix la similaritat per la longitud de l'alineament i per la combinaio de dos en dos del nombre de sequencies

float metodecalculsim1(float res, int num_seqs, int longalin, float puntuaciomatch){
  //printf("%f %d %d %f %d\n", res, num_seqs, longalin, puntuaciomatch,comb_2(num_seqs));
  return (res/(comb_2(num_seqs)*longalin*puntuaciomatch));
}

//Comb_n_k
int comb_nk(int n, int k){
  float r=1,i;
  if (k>n/2) k=n-k;
  for (i=0;i<k;i++) r =r * (n-i)/(k-i);
  return (int)r;
}


/* comb_2 **********************************************************/
//combinacions en base 2

int comb_2(int i)
{
	return (i*(i-1)/2);
}


/* es_nucleotid **********************************************************/
//Ens diu si el carcter que li passem com a parmetre correspon a alguns
//dels: A, C, G, T

int es_nucleotid(char c)
{
	int resposta;
	
	c = toupper(c);
       
	return ((c == 'A') || (c == 'C') || (c == 'G') || (c == 'T') || (c=='N'));
}

int complementari(int base,int alf,int midaalf){
  if (alf == 0) 
    if (base < 4) return midaalf-2-base;
    else return base;
  else {
      printf("No esta fet el reverse\n");
      exit(-1);
  }
}



/* maxim_real *****************************************************************/
//Retorna a int quin es el mxim de tres nombres reals pero si hi ha complementaries
//retorna la mateixa opcio
int posiciomaxim_3floats(float x, float y, float z, int revseq,int cluster)
{
  int res;
  float maxim;
  if (revseq && cluster%2 == 0){
    if (x <= y) {res=2;maxim=y;}
    else {res=1;maxim=x;}
    if (maxim <   z ){res=3;}
  }
  else
    if (revseq && cluster%2 == 1){
      if (z <= y) {res=2;maxim=y;}
      else {res=3;maxim=z;}
      if (maxim <   x ){res=1;}
  }
    else{
      if (x <= y) {res=2;maxim=y;}
      else {res=1;maxim=x;}
      if (maxim <   z ){res=3;}
    }
  return res;
}


float maxim_3floats(float x, float y, float z)
{
  float maxim;
  if (x < y)    maxim = y;
  else maxim = x;
  if (maxim <   z ) maxim = z;
  return maxim;
}


void mostrar_matriu(float **m, int files, int cols)
{
	int i,j;
	
	for (i = 150;i < files;i++)
	{
		for (j = 150;j < cols;j++)
		{
			printf("%f ",m[i][j]);
		}
		printf("\n");
	}
}

char basecompl (char c){
  char aux;
  if (c=='A') aux='T';
  else if (c=='C') aux='G';
  else if (c=='G') aux='C';
  else if (c=='T') aux='A';
  else if (c=='N') aux='N';
  return (aux);
}

char int2DNA(int x){
  char c;
  switch (x){
      case (0): c='A';break;
      case (1): c='C';break;
      case (2): c='G';break;
      case (3): c='T';break;
      case (4): c='N';break;
      }
  return(c);
}


char* int2seq(char* s, int x,int longmer, int alf,int tipus){
  //si tipus=1 ha d'escriure tot el long mer, si 0 nomes el =de mes a la dreta
  int i, r;
  char c;
  //char  s[MAXLONGMER];

  if (!tipus) {
    longmer=1;
    switch (alf) {
      case 0: x=x%ALF_DNA;break;
      case 1: x=x%ALF_AMINO;break;
      case 2: x=x%ALF_CODO;break;
      } 
  }
  //printf("alf=%d longmer=%d valor=%d\n",alf,longmer,x);
  if (alf == 0){
    s[longmer]='\0';
    for (i=0;i<longmer;i++){
      r=x%ALF_DNA;
      x=x/ALF_DNA;
      switch (r){
      case (0): c='A';break;
      case (1): c='C';break;
      case (2): c='G';break;
      case (3): c='T';break;
      case (4): c='N';break;
      }
      s[longmer-1-i]=c;
    }
    //printf("%s\n",s);
  }
  else if (alf ==1){
    s[longmer]='\0';
    for (i=0;i<longmer;i++){
      r=x%ALF_AMINO;
      x=(unsigned long int)x/ALF_AMINO;
      
      switch (r){
      case (0): c='A';break;
      case (1): c='C';break;
      case (2): c='D';break;
      case (3): c='E';break;
      case (4): c='F';break;
      case (5): c='G';break;
      case (6): c='H';break;
      case (7): c='I';break;
      case (8): c='K';break;
      case (9): c='L';break;
      case (10): c='M';break;
      case (11): c='N';break;
      case (12): c='P';break;
      case (13): c='Q';break;
      case (14): c='R';break;
      case (15): c='S';break;
      case (16): c='T';break;
      case (17): c='V';break;
      case (18): c='W';break;
      case (19): c='Y';break;
      }
      s[longmer-1-i]=c;
    }
  }
  else {//escriure codo
     s[longmer*3]='\0';
    for (i=0;i<longmer*3;i++){
      r=x%ALF_DNA;
      x=(unsigned long int)x/ALF_DNA;
      switch (r){
      case (0): c='A';break;
      case (1): c='C';break;
      case (2): c='G';break;
      case (3): c='T';break;
      }
      s[longmer*3-1-i]=c;
    }
  }
  return s;
}

 unsigned long int expon(unsigned int x,unsigned int y){
  unsigned int r=1;
  while (y-->0) r=r*x;
  return r;
}

unsigned long int acgt2ulint(char c){
  unsigned int r;
  switch (c){
  case ('A'): r=0;break;
  case ('C'): r=1;break;
  case ('G'): r=2;break;
  case ('T'): r=3;break;
  case ('N'): r=4;break;
  }
  return r;
}	


unsigned long int amino2ulint(char c){
  unsigned int r;
  switch (c){
  case ('A'): r=0;break;
  case ('C'): r=1;break;
  case ('D'): r=2;break;
  case ('E'): r=3;break;
  case ('F'): r=4;break;
  case ('G'): r=5;break;
  case ('H'): r=6;break;
  case ('I'): r=7;break;
  case ('K'): r=8;break;
  case ('L'): r=9;break;
  case ('M'): r=10;break;
  case ('N'): r=11;break;
  case ('P'): r=12;break;
  case ('Q'): r=13;break;
  case ('R'): r=14;break;
  case ('S'): r=15;break;
  case ('T'): r=16;break;
  case ('V'): r=17;break;
  case ('W'): r=18;break;
  case ('Y'): r=19;break;
  }
  return r;
}
 
char int2amino(int x){

  char c;
    switch (x){
     case (0): c='A';break;
     case (1): c='C';break;
     case (2): c='D';break;
     case (3): c='E';break;
     case (4): c='F';break;
     case (5): c='G';break;
     case (6): c='H';break;
     case (7): c='I';break;
     case (8): c='K';break;
     case (9): c='L';break;
     case (10): c='M';break;
     case (11): c='N';break;
     case (12): c='P';break;
     case (13): c='Q';break;
     case (14): c='R';break;
     case (15): c='S';break;
     case (16): c='T';break;
     case (17): c='V';break;
     case (18): c='W';break;
     case (19): c='Y';break;
     }
  return c;
}


// Entro amb un caracter c llegit
//retorna 0 si no ha pogut completar el numero

int esDNA(char c){
  return (( c=='A') || (c=='C') || (c=='G') || (c=='T') || (c=='N'));
}

int esAMINO(char c){
  return (((int)c>64) && ((int)c<91) && (c!='B') && (c!='J') && (c!='0') && (c!='U') && (c!='X') && (c!='Z'));
}
int primermerDNA(FILE *fgen, char *c, unsigned int longamer, int *r){
  int i;
  *r=0; i=0;
  while ((i<longamer) && (*c!=EOF) && (*c!='>')) {
    if (esDNA(*c)){ 
      i++;
      *r=*r*ALF_DNA+acgt2ulint(*c);
      //printf("%d %c %d\n",i,*c,*r);
    }
    *c=toupper(getc(fgen));
  }
  return (i!=longamer);
}

int primermerAMINO(FILE *fgen, char *c, unsigned int longamer,int *r){
  int i;
  *r=0; i=0;
  while ((i<longamer) && (*c!=EOF) && (*c!='>')) {
    if (!esAMINO(*c)) {
      i=0;
      *r=0;
    }
    else{
      i++;
      *r=*r*ALF_AMINO+amino2ulint(*c);
      //printf("%d %c %d\n",i,*c,*r);
    }
    *c=toupper(getc(fgen));
  }
  return (i!=longamer);
}
