#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>
#include <memory.h>
#include "clus.h"
#include "parells.h"
#include "align.h"

void main(int argc, char * argv []){
  //tracta la informacio dels clusters
  //afegeixo parametre per tractarla
  //no imprimeix els microsatelits divisors
  //treu microsatelits de 3
  //tracta milers de contigs

   char c;
   char patro[MAXLONGPATRO];
   //
   //VARIABLES DEL TEXT
   //
   FILE *fdseq,*ftaula;
   struct stat statbuf;
   unsigned long int longgen; //longitud del genoma
   unsigned long int numcontigs;//numero de contigs
   unsigned long int longcontig[MAXNUMCONTIGS];
   char *gen;//conte el genoma
   //char *llavor;//conte la llavor de la cerca de clusters que retorna carpatro

   //
   //PARAMETRES DEL PROGRAMA
   //
   char *nomsatellit, *nomgenoma; 
   int primercontig;
   unsigned long int minnumrepcluster;//minim numero de repeats en un cluster
   int contigseleccionat;//0 si tots o el primer
   int darrercontig;// darrer seleccionat
   unsigned long int longcluster;//longitud del cluster
   unsigned long int longpatro;//longitud del patro
   int rangacceptats;//longitud de interval de repeats acceptats
   int percentatgeacceptats;//minim percentatge de repeats acceptats
   int minnumrepacc;//minim numero de repeats acceptats en un cluster
   int minlrep,maxlrep;//interval pels repeats valids
   int opcioacceptats,opciorebutjats; // defineix tipus de repeats a imprimir 
   //
   //VARIABLES DEL PROGRAMA
   //
   int nsatellit=1;
   int esc_clusters_acceptats,esc_clusters_rebutjats;// si informa dels acceptats/rebutjats
   int infocluster; // si informa del cluster
   int esc_repre;//si escriu un representant de cada cluster
   int esc_tots_repeats;//si escriu tots els repeats
   int esc_repeats_escollits;//escriu nomes els repeats escollits
   int errorscluster;//errors al buscar el patro  dins cada cluster
   int infoalign;//si fa alinea repeats
   int formatfasta;//treu la llista de consensus en format fasta
   unsigned long int numpatrons,numpatronsdivbase;//numero de patrons possibles
   int base;// si tenim 4 o 5 simbols (amb o sense n's)
   //
   //VARIABLES DEL INVARIANT DEL BUCLE PRINCIPAL
   //
   unsigned int *rep;//compta les aparicions del patro en les ultimes longcluster bases
   unsigned int *reptotals;//compta les aparicions consecutives
   unsigned long int *inicluster,*ficluster;
   unsigned int *filtre;//indica quins patrons eliminem per periodicitat, ...
   int acceptats,rebutjats,numrepeats;//porta el compte de clusters acceptats/rebutjats
   unsigned long int contig;// contig en tractament
   int n;//posicio en tractament respecte del genoma
   unsigned long int poscontig;//posicio en tractament respecte del contig
   unsigned long int posficluster,posinicluster;//cluster en tractament:[n,n+longcluster]
   unsigned long int appatro;// patro en tractament: ultim del cluster
   unsigned long int appatroini;// patro en tractament: primer del cluster
   unsigned int escritcontig=0;// indica si s'ha escrit el cluster
   unsigned long int escollit;//es el patro representatiu del cluster
   //
   //ALTRES VARIABLES
   //
   unsigned long int *pos,pot,i,j,inf;
   unsigned long int ntrobats, posinicontig;
   unsigned long int ini,fi,reps;
   int x,y,infoacceptat,long_rep_acceptats,alf,midaalf,ncolssortalin,longmer,revseq;
   int esc_concensus,esc_alin,alin_tots_repeats, alin_repeats_escollits;
   FILE *fmatpesos;
   //   
   //INFORMACIO PROGRAMA I PARAMETRES
   //
   if((argc!=13) && (argc!=14) && (argc!=17)){
     printf("./clus \n");
     printf("    1: genome (*.fa): multi fasta file\n");
     printf("    2: minim number of seeds into the cluster\n");
     printf("    3: cluster length\n");
     printf("    4: seed length\n");
     printf("    5: minimum repeat length, 0 all\n");
     printf("    6: maximmum repeat length, 0 all\n");
     printf("    7: accepted clusters:\n");
     printf("       0: do not print\n");
     printf("       1: print the list of accepted clusters\n");
     printf("       2: print the list of accepted clusters with representative repeat\n");
     printf("       3: print the list of accepted clusters with all repeats\n");
     printf("       4: print the list of accepted clusters with selected repeats\n");
     printf("    8: rejected clusters:\n");
     printf("       0: do not print\n");
     printf("       1: print the list of rejected clusters\n");
     printf("       2: print the list of rejected  clusters with all repeats\n");
     printf("    9: number of errors to search the seed in the cluster sequence\n");
     printf("    10: align clusters:\n");
     printf("       0: do not align\n");
     printf("       1: print the consensus of all repeats in fasta format\n");
     printf("       2: print the consensus of selected repeats in fasta format\n");
     printf("       3: print the alignment of all repeats\n");
     printf("       4: print the alignment of selected repeats\n");
     printf("    11: prefix of satellite names\n");
     printf("    12: file with the output table of data\n");
     printf("    If the alignment is done:\n");
     printf("           13: file with the weigt matrix\n");
     printf("                OPTIONAL:\n");
     printf("                14:   gap openning (-3)\n");
     printf("                15:   gap extension (-1)\n");
     printf("                16:   gap extrem (-0.5)\n");
     exit(-1);
   }
   alf=0;
   midaalf=ALF_DNA;
   longmer=1;
   revseq=0;
   //
   //LECTURA PARAMETRES
   //
   //Llegir fitxer multifasta genoma
   if(!(fdseq = fopen(argv[1],"r"))){
      printf("error: opening data file 1:  \n");
      exit(-1);
   }
   
   nomgenoma=argv[1];
   tractarnomgenoma(nomgenoma);
   
   fstat(fileno(fdseq), &statbuf);
   inf = statbuf.st_size;
   //Llegir primer i darrer contigs seleccionats
   primercontig=1;
   contigseleccionat=0;
   darrercontig=0;
   printf("The program is running with the following parameters:\n");
   if (contigseleccionat == 0) printf("   All contigs\n");
   else printf ("   From contig %d to contig %d\n",contigseleccionat,darrercontig);
   minnumrepcluster=atoi(argv[2]);
   printf("   Minimum number of repeats %lu\n",minnumrepcluster);
   longcluster=atoi(argv[3]);// longitud del cluster
   printf("   Length of the cluster %ld\n",longcluster);
   longpatro=atoi(argv[4]);// longitud del patro
   printf("   Length of the motif seed %lu\n",longpatro);
   rangacceptats=1;// rang acceptats
   printf("   Accepted repeat length interval +- %d\n",rangacceptats);
   percentatgeacceptats=30;// percentatge minim d'acceptats sobre el total
   printf("   Minimum percentage of accepted repeats %d\n",percentatgeacceptats);
   minnumrepacc=1;
   printf("   Minimum number of accepted repeat %d\n",minnumrepacc);
   minlrep=atoi(argv[5]);
   minlrep=maxim(minlrep,longpatro);
   maxlrep=atoi(argv[6]);
   if (maxlrep==0) maxlrep=100000;
   printf("   Length of accepted sequences: between %d and %d\n",minlrep,maxlrep); 
   infocluster=0;
   esc_tots_repeats=0;
   esc_repre=0;
   opcioacceptats=atoi(argv[7]);
   if (opcioacceptats>0) {
     printf("   The list of accepted clusters will be printed ");
     switch (opcioacceptats){
     case 1 : printf("\n");break;
     case 2 : printf("with a representative repeat\n");break;
     case 3 : printf("with all the repeats \n");break;
     case 4 : printf("with the selected repeats\n");break;
     }
   }
   esc_clusters_acceptats=0 ;esc_repeats_escollits=0;
   if (opcioacceptats > 0){ esc_clusters_acceptats=1;infocluster=1;}
   if (opcioacceptats == 2) esc_repre =1;//escriu els representants
   if (opcioacceptats > 2 ) esc_tots_repeats=1;
   if (opcioacceptats > 3) esc_repeats_escollits=1;
   if (opcioacceptats > 4) {printf("Valor clusters acceptats erroni\n");exit(1);}
   opciorebutjats=atoi(argv[8]);
 if (opciorebutjats>0) {
	printf("   The list of rejected clusters will be printed ");
	switch (opciorebutjats){
	case 1 : printf("\n");break;
	case 2 : printf("with all repeats \n");break;
	}
      }
   esc_clusters_rebutjats=0 ;
   if (opciorebutjats > 0 ) esc_clusters_rebutjats=1;
   if (opciorebutjats > 1) {infocluster=1;esc_tots_repeats=1;}
   if (opciorebutjats> 2) {printf("Valor clusters rebutjats erroni\n");exit(1);}
   if ((opcioacceptats>0) && (opciorebutjats>0) && (opcioacceptats!=opciorebutjats)) {printf("Valor clusters acceptats i rebutjats igual\n");exit(1);}
   errorscluster=atoi(argv[9]);
   printf("   Errors accepted while aligning repeats of a cluster: %d\n",errorscluster);
   infoalign=atoi(argv[10]);
   if (infoalign>0){
     if (argc<14){printf("Fatal error:Falten parametres alineament\n");exit(-1);}
     if (!opcioacceptats) {printf("Fatal error: Cal activar alguna opcio del clusters acceptats\n");exit(-1);}
     printf("   The list of accepted clusters will be printed ");
     switch (infoalign){
     case 1 : printf("    The consensus of all repeats will be printed\n");break;
     case 2 : printf("    The consensus of selected repeats will be printed\n");break;
     case 3 : printf("    The alignment and consensus  of all repeats will be printed\n");break;
     case 4 : printf("    The alignment and consensus of selected repeats will be printed\n");break;
     }
     reservar_memoria_alineament(alf,midaalf,longmer,revseq);
     //obro i llegeixo matriu pesos
     if(!(fmatpesos = fopen(argv[13],"r"))){
       printf("error: opening fitxer matriu pesos \n");
       exit(-1);
     }
     for (i=0;i<midaalf;i++)
       for (j=0;j<midaalf;j++){
	 fscanf(fmatpesos,"%f",&matpesos[i][j]);
	 //printf("matpeoso[%d][%d]=%f\n",i,j,matpesos[i][j]);
       }
     fclose(fmatpesos);
     ncolssortalin=80;
     formatfasta=0;
     esc_concensus=0;
     esc_alin =0;
     alin_tots_repeats=0;
     alin_repeats_escollits=0;
     
     infocluster=1;
     if ((infoalign==1) ||(infoalign==2)) {formatfasta=1;esc_concensus=1;}
     if ((infoalign==1) ||(infoalign==3)) {alin_tots_repeats=1;}
     if ((infoalign==2) ||(infoalign==4)){alin_repeats_escollits=1;}
     if ((infoalign==3) || (infoalign==4)){esc_alin=1;}
     
   }    
   
   nomsatellit= argv[11];
   if(!(ftaula = fopen(argv[12],"w"))){
      printf("error: opening data file output:  \n");
      exit(-1);
   } 
   initaula(ftaula);
   printf("   Prefix satellite name: %s\n",nomsatellit);
   printf("   Output file (gff3 table) %s\n",argv[18]);
   
   if (argc == 19){
     PUNTUACIO_FORAT_OP = atof(argv[14]);
     PUNTUACIO_FORAT_EXT = atof(argv[15]);
     PUNTUACIO_FORAT_INI = atof(argv[16]);
   }
   else{  //Posem els valors per defecte
     PUNTUACIO_FORAT_INI = -0.5;  
     PUNTUACIO_FORAT_OP = -3;    
     PUNTUACIO_FORAT_EXT = -1;    
   }
   if (infoalign > 0) {
     printf("Alignment parameters:\n");
     printf("        Gap openning = %f\n",PUNTUACIO_FORAT_OP);
     printf("        Gap extension = %f\n", PUNTUACIO_FORAT_EXT);
     printf("        Gap extreme = %f\n", PUNTUACIO_FORAT_INI);
   }
   //
   //LECTURA DEL GENOMA
   //
   if(!(gen = (unsigned char *)malloc(++inf))){ printf("size NOK \n");exit(0);}
   
   // detecto si hi ha n's. base=5 A,C,G,T,N ==> tracta la N com les altres
   c=getc(fdseq);
   base=4;
   while((c!=EOF) && (base==4)){
     if (c=='>'){
       while (c!='\n') c=getc(fdseq);
       while ((c!=EOF) && (c!='A') &&(c!='C') &&(c!='G') &&(c!='T') &&(c!='N')) 
	 c=toupper(getc(fdseq));
       }
     else if (c=='N') base=5;
     else c=toupper(getc(fdseq));
   }
   //
   //ESPAI DE PATRONS
   //
   numpatrons=potencia(base,longpatro);
   numpatronsdivbase=potencia(base,longpatro-1);
   //
   //RESERVA DE MEMORIA PELS VECTORS I MATRIUS DE DADES
   //
   if(!(rep = malloc(numpatrons*sizeof(unsigned int)))){ printf("size NOK \n");exit(0);}
   if(!(reptotals = malloc(numpatrons*sizeof(unsigned int)))){ printf("size NOK \n");exit(0);}
   if(!(inicluster = malloc(numpatrons*sizeof(unsigned long int)))){ printf("size NOK \n");exit(0);}
 if(!(ficluster = malloc(++numpatrons*sizeof(unsigned long int)))){ printf("size NOK \n");exit(0);}
    if(!(filtre = malloc(numpatrons*sizeof(int)))){ printf("size NOK \n");exit(0);}
    //reservo memoria per a la matriu de programacio dinamica    
    progdim = (int **) malloc ((MAXLONGCLUSTER+1)*sizeof(int *));
    if (progdim == NULL) {printf("\n Error assignacio memoria clus:progdim");exit(0);}
    for(i=0;i <= MAXLONGCLUSTER;i++){
      progdim[i] = (int *) malloc((longpatro+1) * sizeof(int));
      if (progdim[i] == NULL) {
	printf("\n Error assignacio memoria clus:progdim[%ld]",i);exit(0);}
    }
    progdimcami = (char **) malloc ((MAXLONGCLUSTER+1)*sizeof(char *));
    if (progdimcami == NULL) {printf("\n Error clus:progdimcami");exit(0);}
    for(i=0;i <= MAXLONGCLUSTER;i++){
      progdimcami[i] = (char *) malloc((longpatro+1) * sizeof(char));
      if (progdimcami[i] == NULL) {
	printf("\n Error clus:progdimcami[%ld]",i);exit(0);}
    }


    //
    //SELECCIO DE PATRONS VALIDS
    //
   for (i=0;i<numpatrons;i++) filtre[i]=0;
   filtrepatrons(filtre,longpatro,base);

   if (formatfasta == 0){
     printf("\n--------------------------------------------------\n\n ");
   }

   //
   //COMPTO ELS CONTIGS
   //
   fseek(fdseq,0,SEEK_SET);
   c=toupper(getc(fdseq));
   numcontigs=primercontig-1; 
   longgen=0;

   while(c!=EOF) {
     //llegeixo contig
     //passo tots els caracters abans de >
     //while ((c!=EOF) && (c!='A') &&(c!='C') &&(c!='G') &&(c!='T') &&(c!='N')&&(c!='>')  ) c=toupper(getc(fdseq));
     while ((c!=EOF) && (c!='>')  ) c=getc(fdseq);
     if (c=='>') {
       numcontigs++;longcontig[numcontigs]=0;
       //printf("contig %d: ",numcontigs);
       while (c!='\n') {
	 c=getc(fdseq);
	 //printf("%c",c);
       }
       gen[longgen]='>';
       //printf("%c",gen[longgen]);
       longgen++;    
     }
     
     //passo possibles caracters especials
     while ((c!=EOF) && (c!='A') &&(c!='C') &&(c!='G') &&(c!='T') &&(c!='N')&&(c!='>')  ) c=toupper(getc(fdseq));
     //llegeixo contig
     while((c!=EOF)&&(c!='>')){
       gen[longgen]=c;
       //printf("%c",gen[longgen]);
       longgen++; 
       longcontig[numcontigs]++;
       c=toupper(getc(fdseq));
       while ((c!=EOF) && (c!='A') &&(c!='C') &&(c!='G') &&(c!='T') &&(c!='N')&&(c!='>')  ) c=toupper(getc(fdseq));
     }
     //printf(": length %d ",longcontig[numcontigs]); 

     //printf("\n\n");
   }


   longgen++; 
   if (formatfasta == 0) {
     printf("Genome: %s\n",nomgenoma);
     printf("   Number of contigs: %lu \n",numcontigs);
     printf("   Length: %lu\n\n",longgen-numcontigs-1);
     printf("\n--------------------------------------------------\n\n ");
   }
   //
   //**********************     PROGRAMA   ****************************//
   //
   //INICIALITZACIONS
   //
   acceptats=0;rebutjats=0;
   contig=primercontig;
   numcontigs=numcontigs+primercontig;
   n=1;
   //si hi ha un contig seleccionat busco el principi
   if (contigseleccionat>0)
     while (contig!=contigseleccionat)
       {n=n+longcontig[contig]+1;contig++;} 
   //entro amb el seleccionat o el primer i al final ho controlo
   while ((contig<=numcontigs) && ((contigseleccionat==0) || (contigseleccionat>0 && contig <= darrercontig))){
     //INICIALITZACIO DE COMPTADORS  PER CADA CONTIG
     for (i=0;i<numpatrons;i++) rep[i]=0;
     for (i=0;i<numpatrons;i++) {ficluster[i]=0;inicluster[i]=0;}
     for (i=0;i<numpatrons;i++) reptotals[i]=0;
     
     //printf(">Contig %d Length %d \n",contig,longcontig[contig]);
     //INICIALITZACIONS PEL PRIMER CLUSTER
      poscontig=1;
      posinicluster=n;
      posficluster=posinicluster+longcluster-1;
      posinicontig=n;

      //LLEGEIXO PRIMER PATRO
      appatro=0;
      while (poscontig<=longpatro){
	appatro = appatro*base + valorcar(gen[n]);
        poscontig++;n++;
      }
      inicluster[appatro]=n-longpatro;
      (rep[appatro])++;(reptotals[appatro])++;
      appatroini=appatro;
      escollit=appatro;
      //printf("escollit %u reptotals=%d [%u,%u] \n",escollit, reptotals[escollit],inicluster[escollit],ficluster[escollit]);
      //
      // He definit: rep=reptotals,inicluster,ficluster,escollit      
      //
      //LLEGEIXO FINS FI DEL PRIMER CLUSTER

      while((gen[n]!='>') && (n<longgen) && (poscontig<=longcluster)){
	//determina appatro
	appatro=(appatro-numpatronsdivbase*valorcar(gen[n-longpatro]))*base+valorcar(gen[n]);
	//actualitza cluster
	(rep[appatro])++;reptotals[appatro]++;  
	ficluster[appatro]=n;
	if (inicluster[appatro]==0) inicluster[appatro]=n-longpatro;
	//actualitza escollit
	if (filtre[escollit]==1) escollit=appatro;
	else if (filtre[appatro]==0)
	  if (reptotals[escollit]<reptotals[appatro])
	  escollit=appatro;
	poscontig++;
	n++;
      }
      //Per a cada patron aparegut he definit:
      //rep=reptotals,inicluster, ficluster, es a dir el seu possible cluster 
      //escollit que es el patro de l'ultim cluster trobat 
      
      // LLEGEIXO RESTA DEL CONTIG
      //printf("Seguent patro i cluster\n");
      while((gen[n]!='>') && (n<longgen)){
	//determino limits del cluster actiu
	posinicluster++;posficluster++;
	//determino appatro
	appatro=(appatro-numpatronsdivbase*valorcar(gen[n-longpatro]))*base+valorcar(gen[n]);
	//printf("+%d %c\n",appatro,gen[n]);
	if (rep[appatro]==0){
	  //vol dir que torna a sortir despres de mes de longcluster de no sortir  
	  if ((appatro==escollit) &&  (reptotals[escollit]>=minnumrepcluster) && filtre[escollit]==0){
	    //si es igual a l'escollit del ultim cluster i cal escriure'l ...
	    if (escritcontig==0){
	      //printf(">Contig %lu  \n",contig);
	      if (formatfasta == 0 ) 
		//printf(">Contig(A) %lu Length %lu \n",contig,longcontig[contig]);
	      escritcontig=1;
	    }
	    //estudio el cluster del escollit
	    esacceptat(gen,longpatro,&numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,&acceptats,&rebutjats,&infoacceptat,&long_rep_acceptats,&percentatgeacceptats,&minnumrepacc,rangacceptats,minlrep,maxlrep,minnumrepcluster);
	    //printf("surt esacceptat A\n");
	    //printf("Infoacceptat=%d acceptats=%d rebutjats=%d\n",infoacceptat,acceptats,rebutjats);
	    if ((infoacceptat && esc_clusters_acceptats) || (!(infoacceptat) && esc_clusters_rebutjats)){
	      imprimir(ftaula,nomgenoma,inf,nomsatellit,contig,inicluster[escollit]-posinicontig,ficluster[escollit]-posinicontig, ficluster[escollit]-inicluster[escollit]+1,numrepeats,long_rep_acceptats,longpatro,escollit,base);
	      //fase
	      
	      //if (formatfasta == 1) printf(" contig %lu",contig);
	      if ((opcioacceptats>0) && (opciorebutjats>0))
		if (infoacceptat==1) printf("   Acceptat");
		else printf("   Rebutjat");
	      //printf("\n");
	      if ((escollit%base!=4) && (infocluster==1)) {
		//printf("Tracto cluster A\n");
		tractar_cluster(ftaula,gen,longpatro,numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,esc_repeats_escollits,long_rep_acceptats,infoalign,rangacceptats,esc_tots_repeats,esc_repre,esc_concensus,esc_alin,alin_tots_repeats, alin_repeats_escollits);
	      }
	    }
	  }
	  //com que ja l'ha escrit o no era igual a escollit, inicialitza dades del nou cluster
	  reptotals[appatro]=0;
	  inicluster[appatro]=n-longpatro;
      	}
	rep[appatro]++; 
	ficluster[appatro]=n;
	reptotals[appatro]++; 
	//printf("-%d\n",appatroini);
	rep[appatroini]--;
	appatroini=(appatroini-numpatronsdivbase*valorcar(gen[n-longcluster]))*base+valorcar(gen[n-longcluster+longpatro]);
	
	//analitzo el nou cluster. Te mes de minnumrepcluster repeats i es un patro valid?
	if ((rep[appatro]>=minnumrepcluster) && (filtre[appatro]==0)){
	  //he trobat un nou cluster valid i miro si hi ha interseccio amb escollit
	  if (ficluster[escollit]>inicluster[appatro]){
	    //hi ha interseccio i miro si n'ha trobat mes de repeats
	    if (reptotals[escollit]<reptotals[appatro])
	      //defineixo el nou escollit
	      escollit=appatro;
	  }
	  else {
	    //no hi ha interseccio entre appatro i escollit. 
	    //vol dir que el cluster escollit ha quedat enrera i cal estudiar-lo per imprimir-lo o no
	    if (reptotals[escollit]>=minnumrepcluster){
	      if (escritcontig==0){
		if (formatfasta == 0 )
		  //printf(">Contig(B) %lu Length %lu \n",contig,longcontig[contig]);
		//printf(">Contig %lu \n",contig);
		escritcontig=1;
	      }
	      esacceptat(gen,longpatro,&numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,&acceptats,&rebutjats,&infoacceptat,&long_rep_acceptats,&percentatgeacceptats,&minnumrepacc,rangacceptats,minlrep,maxlrep,minnumrepcluster);
	      if ((infoacceptat && esc_clusters_acceptats) || (!(infoacceptat) && esc_clusters_rebutjats)){
		imprimir(ftaula,nomgenoma,inf,nomsatellit,contig,inicluster[escollit]-posinicontig,ficluster[escollit]-posinicontig, ficluster[escollit]-inicluster[escollit]+1, numrepeats,long_rep_acceptats,longpatro,escollit,base);
		//fase 3
		//if (formatfasta == 1) printf(" contig %lu",contig);
		if ((opcioacceptats>0) && (opciorebutjats>0))
		  if (infoacceptat ==1) printf("    Acceptat");
		  else printf("   Rebutjat");
		//printf("\n");
		if ((escollit%base!=4) && (infocluster)){ 
		  //printf("\n tracto cluster B");
		  tractar_cluster(ftaula,gen,longpatro,numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,esc_repeats_escollits,long_rep_acceptats,infoalign,rangacceptats,esc_tots_repeats,esc_repre,esc_concensus,esc_alin,alin_tots_repeats, alin_repeats_escollits);
		}
	      }
	    }
	    //despres de estudiar escollit se li assigna el valor de appatro
	    escollit=appatro;
	  }	
	}
	poscontig++;
	n++;
      }
      //escric ultim escollit
      //printf("\n Final:%d ",reptotals[escollit]);
      //carpatro(longpatro,escollit,base);
      if ((reptotals[escollit]>=minnumrepcluster) && (filtre[escollit]==0)) {
	if (escritcontig==0){
	  if (formatfasta == 0) 
	    //printf(">Contig(C) %lu Length %lu \n",contig,longcontig[contig]);
	  //printf(">Contig %lu \n",contig);
	      escritcontig=1;
	    }
	//printf("Crido esacceptat\n");
	esacceptat(gen,longpatro,&numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,&acceptats,&rebutjats,&infoacceptat,&long_rep_acceptats,&percentatgeacceptats,&minnumrepacc,rangacceptats,minlrep,maxlrep,minnumrepcluster);
	//printf("Torno crida esacceptat\n");
	if ((infoacceptat && esc_clusters_acceptats) || (!(infoacceptat) && esc_clusters_rebutjats)){
	  //fase 5
	  imprimir(ftaula,nomgenoma,inf,nomsatellit,contig,inicluster[escollit]-posinicontig,ficluster[escollit]-posinicontig, ficluster[escollit]-inicluster[escollit]+1,numrepeats,long_rep_acceptats,longpatro,escollit,base);
	  
	  if ((opcioacceptats>0) && (opciorebutjats>0))
	    if (infoacceptat==1) printf("   Acceptat");
	    else printf("    Rebutjat");
	  //printf("\n");
	  if ((escollit%base!=4) && (infocluster)) {
	    //printf("Tracto cluster C\n");
	    tractar_cluster(ftaula,gen,longpatro,numrepeats,base, escollit,inicluster[escollit],ficluster[escollit],errorscluster,esc_repeats_escollits,long_rep_acceptats,infoalign,rangacceptats,esc_tots_repeats,esc_repre,esc_concensus,esc_alin,alin_tots_repeats, alin_repeats_escollits);
	  }
	  escollit=appatro;
	}
      }
      escritcontig=0;
      contig++;
      n++;
      //if (contigseleccionat>0)contig=contig+numcontigs;
   }
   //if (formatfasta == 0)  
     printf("\n Acceptats=%d   Rebutjats=%d \n",acceptats,rebutjats);
   fclose(ftaula);
}


