#include "clus.h"
#include "clusters.h"
#include "auxiliar.h"
#include <string.h>
#include <ctype.h>
#include <math.h>
void inicialitzar_perfil_cluster(tsinfo_cluster_columna *perfil,int alf){
  int j,k,midaalf;
  switch (alf) {
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
  } 
  //printf("comencat\n"); 
  for (j=0;j<MAXLONGSEQ;j++){
    for (k=0;k<midaalf;k++) {
      //printf(" %d %d --- \n",j,k);
      perfil[j].freq[k]=0;
    }
    perfil[j].nogaps=0;
    perfil[j].gap_ini=0;
    perfil[j].gap_op=0;
    perfil[j].gap_ext=0;
    perfil[j].puntsintracluster=0;
  }
  //printf("acabat\n");
}

//Input: file in multifasta format
void llegir_clusters(char *nomfitxerentrada,int numseqs, int alf, int midaalf, int longmer, int revseq)
{
  int i,j,k,nseq,modul,modulsalt;
  int lseq,salt,acabat,mer;
  char c;
  FILE *fentrada;
 
  if(!(fentrada = fopen(nomfitxerentrada,"r"))){
    printf("error: opening sequences file \n");
    exit(-1);}
  switch (alf) {
      case 0: modul = expon(ALF_DNA,longmer-1);salt=1;modulsalt=1;break;
      case 1: modul = expon(ALF_AMINO,longmer-1);salt=1;modulsalt=1;break;
      case 2: modul = expon(ALF_CODO,longmer-1);salt=3;modulsalt=expon(ALF_DNA,2);break;
  }
  
  c=getc(fentrada);
  nseq=0;
  while (!feof(fentrada)){
    //printf(" Perfil Sequencia %d\n",nseq);
    inicialitzar_perfil_cluster(clusters[nseq].perfil,alf);//tot a zero
    clusters[nseq].num_cluster=nseq;
    while(c!='>') c=getc(fentrada);
    //printf("llegir nom sequencia %d i guardar-lo\n",nseq);
    j=0;
    while ((c!='\n')  && (j<MAXLONGNOM) && (c!=' ')){
      c=getc(fentrada);
      clusters[nseq].nom_seq[j]=c;
      //        printf("%c",c);
      j++;
    }
    clusters[nseq].nom_seq[j]='\0';
    //printf("llegir fins final de linia\n");
    while ((c!='\n') && (!feof(fentrada))) c=getc(fentrada);
    //printf("Inicialitzo\n");
    clusters[nseq].quines[0] = nseq;
    clusters[nseq].num_seqs = 1;
    clusters[nseq].puntuacio = 0;

    acabat=0;
    lseq=0;
    //printf("llegir sequencia\n"),
    
    c=toupper(getc(fentrada));//te el primer caracter llegit
    if ((alf == 0) || (alf==2)) acabat=primermerDNA(fentrada,&c,longmer,&mer);
    else acabat=primermerAMINO(fentrada,&c,longmer,&mer);
    if (!acabat) {
      clusters[nseq].perfil[lseq].freq[mer]++;
      clusters[nseq].perfil[lseq].nogaps++;
      matseqs[nseq][lseq]=mer;
      //printf("%2d ",mer);
      lseq++;
    } 
    if ((alf == 0 ) || (alf == 2)){
      while((c!='>')&& (!feof(fentrada))){
	i=0;
	while((c!='>')&& (i<salt) && (!feof(fentrada))){
	  if (esDNA(c)){
	    mer=(mer%modul)*ALF_DNA+acgt2ulint(c);
	    i++;
	  }
	  c=toupper(getc(fentrada));
	}
	if (i==salt){
	  clusters[nseq].perfil[lseq].freq[mer]++;
	  clusters[nseq].perfil[lseq].nogaps++;
	  //clusters[nseq].perfil[lseq].puntsintracluster ja esta inicialitzat a 0
	  matseqs[nseq][lseq]=mer;
	  //printf("%2d ",mer);
	  lseq++;
	}
      }
      //printf("\n");
    }
    else {
      while((c!='>') && (!feof(fentrada))){
	if (esAMINO(c)){
	  mer=(mer%modul)*ALF_AMINO+amino2ulint(c);
	  clusters[nseq].perfil[lseq].freq[mer]++;
	  clusters[nseq].perfil[j].nogaps++;
	  matseqs[nseq][lseq]=mer;
	  lseq++;
	}
	c=toupper(getc(fentrada));
      }
    }

    clusters[nseq].lcluster = lseq;
    clusters[nseq].long_seq = lseq;
    if (lseq==0){
      printf("Error in sequence %d\n",nseq);
      exit(-1);
    }
    //mostrar_info_cluster(clusters[nseq],alf);
    nseq++;
    // creo les complementaries
    if (revseq){
      //printf("Sequencia complementaria %d\n",nseq);
      inicialitzar_perfil_cluster(clusters[nseq].perfil,alf);
      clusters[nseq].num_cluster=nseq;
      clusters[nseq].lcluster = lseq;
      clusters[nseq].long_seq = lseq;
      clusters[nseq].num_cluster=nseq;
      sprintf(clusters[nseq].nom_seq,"Rev.of:%s",clusters[nseq-1].nom_seq);
      //printf("%s\n",clusters[nseq].nom_seq);
      clusters[nseq].quines[0] = nseq;
      clusters[nseq].num_seqs = 1;
      clusters[nseq].puntuacio = 0;
      crea_perfil_complementari(nseq-1,nseq,alf,midaalf);
      omple_fitxer_complementari(nseq,alf,midaalf);
      //mostrar_info_cluster(clusters[nseq],alf);
      nseq++;
    }
   
  }
  fclose(fentrada);
}
void llegir_ordenar_clusters(char *nomfitxerentrada,int numseqs, int alf, int midaalf, int longmer, int revseq)
{
  //els ordeno per les comparacions amb permutacio, permuto el mes llarg
  int i,j,k,l,nseq,modul,modulsalt,pos,auxpos,auxlen;
  int lseq,salt,acabat,mer;
  char c;
  FILE *fentrada;
  int **copiamatseqs;
  typedef struct{int pos;int len;} parell;
  parell *vord;
  tscluster *copiaclusters;

  copiamatseqs = (int **) malloc((numseqs+1) * sizeof(int *));
  if (copiamatseqs == NULL){printf("Out of memory of copiamatseqs \n");exit(-1);}
  for (i = 0;i < numseqs;i++){
    copiamatseqs[i] = (int *) malloc(MAXLONGSEQ * sizeof(int));
    if (copiamatseqs[i] == NULL){printf("Out of memory copiamatseqs[%d]\n",i);exit(-1);}
  }
  vord = (parell *) malloc((numseqs+1) * sizeof(parell));
  if (vord == NULL){printf("Out of memory of vord \n");exit(-1);}
  copiaclusters = (tscluster *) malloc((numseqs+1) * sizeof(tscluster));
  if (copiaclusters == NULL){printf("Out of memory of copiaclusters \n");exit(-1);}
  for (i=0;i<numseqs;i++){
     copiaclusters[i].nom_seq = (char *) malloc(MAXLONGNOM * sizeof(char));
     if (copiaclusters[i].nom_seq == NULL){printf("Out of memory of copiaclusters[%d].nomseq \n",i);exit(-1);}
     copiaclusters[i].quines = (int *) malloc( sizeof(int));
     if (copiaclusters[i].quines == NULL){printf("Out of memory of copiaclusters[%d].quines \n",i);exit(-1);}
  }


  if(!(fentrada = fopen(nomfitxerentrada,"r"))){
    printf("error: opening sequences file \n");
    exit(-1);}
  switch (alf) {
  case 0: modul = expon(ALF_DNA,longmer-1);salt=1;modulsalt=1;break;
  case 1: modul = expon(ALF_AMINO,longmer-1);salt=1;modulsalt=1;break;
  case 2: modul = expon(ALF_CODO,longmer-1);salt=3;modulsalt=expon(ALF_DNA,2);break;
  }
  //llegir clusters de fitxer
  c=getc(fentrada);
  nseq=0;
  while (!feof(fentrada)){
    //printf(" Llegeixo  Sequencia %d\n",nseq);
    
    
    copiaclusters[nseq].num_cluster=nseq;
    while(c!='>') c=getc(fentrada);
    //printf("llegir nom sequencia %d i guardar-lo\n",nseq);
    j=0;
    while ((c!='\n')  && (j<MAXLONGNOM) && (c!=' ')){
      c=getc(fentrada);
      copiaclusters[nseq].nom_seq[j]=c;
      //printf("%c",c);
      j++;
    }
    copiaclusters[nseq].nom_seq[j]='\0';
    //printf("llegir fins final de linia\n");
    while ((c!='\n') && (!feof(fentrada))) c=getc(fentrada);
    //printf("Inicialitzo\n");
    copiaclusters[nseq].quines[0] = nseq;
    //copiaclusters[nseq].num_seqs = 1;
    //copiaclusters[nseq].puntuacio = 0;
    
    acabat=0;
    lseq=0;
    //printf("llegir primer element\n"),
    
    c=toupper(getc(fentrada));//te el primer caracter llegit
    if ((alf == 0) || (alf==2)) acabat=primermerDNA(fentrada,&c,longmer,&mer);
    else acabat=primermerAMINO(fentrada,&c,longmer,&mer);
    if (!acabat) {
      //clusters[nseq].perfil[lseq].freq[mer]++;
      //clusters[nseq].perfil[lseq].nogaps++;
      copiamatseqs[nseq][lseq]=mer;
      //printf("%2d ",mer);
      lseq++;
    } 
    //printf("Llegir resta elements\n");
    if ((alf == 0 ) || (alf == 2)){
      while((c!='>')&& (!feof(fentrada))){
	i=0;
	while((c!='>')&& (i<salt) && (!feof(fentrada))){
	  if (esDNA(c)){
	    mer=(mer%modul)*ALF_DNA+acgt2ulint(c);
	    i++;
	  }
	  c=toupper(getc(fentrada));
	}
	if (i==salt){
	  //clusters[nseq].perfil[lseq].freq[mer]++;
	  //clusters[nseq].perfil[lseq].nogaps++;
	  //clusters[nseq].perfil[lseq].puntsintracluster ja esta inicialitzat a 0
	  copiamatseqs[nseq][lseq]=mer;
	  //printf("%2d ",mer);
	  lseq++;
	}
      }
      //printf("\n");
    }
    else {
      while((c!='>') && (!feof(fentrada))){
	if (esAMINO(c)){
	  mer=(mer%modul)*ALF_AMINO+amino2ulint(c);
	  //clusters[nseq].perfil[lseq].freq[mer]++;
	  //clusters[nseq].perfil[j].nogaps++;
	  copiamatseqs[nseq][lseq]=mer;
	  lseq++;
	}
	c=toupper(getc(fentrada));
      }
    }
    //printf("%d Elements llegits de la seq %d\n",lseq,nseq);
    copiaclusters[nseq].lcluster = lseq;
    copiaclusters[nseq].long_seq = lseq;
    if (lseq==0){
      printf("Error in sequence %d\n",nseq);
      exit(-1);
    }
    mostrar_info_cluster(copiaclusters[nseq],alf);
    nseq++;
  }
  fclose(fentrada);
  //printf("Ordeno els clusters de %d sequencies de menor a major\n",nseq);
  for (i=0;i<nseq;i++){
    vord[i].pos=i;
    vord[i].len=copiaclusters[i].lcluster;
    //printf("vord[%d]=( %d , %d )\n",i,vord[i].pos,vord[i].len);
  }
  //printf("ordeno clusters sobre un vector\n"); 
  for (i=1;i<nseq;i++){
    j=i-1;
    auxpos=vord[i].pos;
    auxlen=vord[i].len;
    while (j>=0 && auxlen < vord[j].len){
      vord[j+1].pos=vord[j].pos;
      vord[j+1].len=vord[j].len;
      j--;
    }
    vord[j+1].pos=auxpos;
    vord[j+1].len=auxlen;
  }
  //for (i=0;i<nseq;i++)
  //printf("vord[%d]=( %d , %d )\n",i,vord[i].pos,vord[i].len);
  //printf("Ara cal ordenar la matriu de sequencies sobre matseqs tenint en compte revseq\n");
  for (i=0;i<nseq;i++){
    for(j=0;j<vord[i].len;j++)
      if (revseq){
	matseqs[2*i][j]=copiamatseqs[vord[i].pos][j];
	//printf("%d ",matseqs[2*i][j]);
      }
      else 
	matseqs[i][j]=copiamatseqs[vord[i].pos][j];
    //printf("\n");
  }

  //printf("i ara cal reordenar els clusters\n");
  for (i=0;i<nseq;i++){
    if (revseq){
      clusters[2*i].num_cluster=2*i;
      sprintf(clusters[2*i].nom_seq,"%s",copiaclusters[vord[i].pos].nom_seq);
      clusters[2*i].long_seq=copiaclusters[vord[i].pos].long_seq;
      clusters[2*i].num_seqs=1;
      clusters[2*i].quines[0]=2*i;
      clusters[2*i].lcluster=clusters[2*i].long_seq;
      clusters[2*i].puntuacio=0;
      inicialitzar_perfil_cluster(clusters[2*i].perfil,alf);//tot a zero
      for (l=0;l<clusters[2*i].long_seq;l++){
	clusters[2*i].perfil[l].freq[matseqs[2*i][l]]=1;
	clusters[2*i].perfil[l].nogaps=1;
	
      }
      //printf("seq[%d] feta\n",2*i);
      //mostrar_info_cluster(clusters[2*i],alf);
    }
    else{
      clusters[i].num_cluster=i;
      sprintf(clusters[i].nom_seq,"%s",copiaclusters[vord[i].pos].nom_seq);
      clusters[i].long_seq=copiaclusters[vord[i].pos].long_seq;
      clusters[i].num_seqs=1;
      clusters[i].quines[0]=i;
      clusters[i].lcluster=clusters[i].long_seq;
      clusters[i].puntuacio=0;
      inicialitzar_perfil_cluster(clusters[i].perfil,alf);//tot a zero
      for (l=0;l<clusters[i].long_seq;l++){
	clusters[i].perfil[l].freq[matseqs[i][l]]=1;
	clusters[i].perfil[l].nogaps=1;
      }
      //printf("seq[%d] feta\n",i);
    }
  }
 
  // si revseq creo les complementaries
  if (revseq)
    for (i=0;i<nseq;i++) {
      pos=2*i+1;
      //printf("Sequencia complementaria %d\n",nseq);
      inicialitzar_perfil_cluster(clusters[pos].perfil,alf);
      clusters[pos].num_cluster=pos;
      clusters[pos].lcluster = clusters[pos-1].lcluster;
      clusters[pos].long_seq = clusters[pos-1].long_seq;
      sprintf(clusters[pos].nom_seq,"Rev.of:%s",clusters[pos-1].nom_seq);
      //printf("%s\n",clusters[nseq].nom_seq);
      clusters[pos].quines[0] = pos;
      clusters[pos].num_seqs = 1;
      clusters[pos].puntuacio = 0;
      crea_perfil_complementari(pos-1,pos,alf,midaalf);
      omple_fitxer_complementari(pos,alf,midaalf);
      //printf("seq[%d] feta\n",pos);
      //mostrar_info_cluster(clusters[pos-1],alf);
      //mostrar_info_cluster(clusters[pos],alf);
    }
}
  //omple fitxer a prtir del perfil
void omple_fitxer_complementari(int nseq, int alf, int midaalf){
  int i,j;
  int lseq=clusters[nseq].long_seq;
  //printf("Omplo fitxer %d\n",nseq);
  if (alf == 0){
    for (i=0;i<lseq;i++){
      j=0;
      while (j<midaalf && clusters[nseq].perfil[i].freq[j] == 0) j++;
      matseqs[nseq][i]=j;
      //printf("%2d ",j);
      }
    //printf("\n");
  }
  else {
    printf("No esta fet el reverse\n");
    exit(-1);
  }
}

//a cluster[j] hi crea el perfil complementari de cluster[i]  
void crea_perfil_complementari(int i,int j,int alf, int midaalf){
  int lseq=clusters[i].long_seq;
  int l,m;
  // printf("lseq %d midaalf %d \n",lseq,midaalf);
  for (l=0;l<lseq;l++){
    for (m=0;m<midaalf;m++)
      clusters[j].perfil[l].freq[m]=clusters[i].perfil[lseq-l-1].freq[complementari(m,alf,midaalf)];
    clusters[j].perfil[l].nogaps=clusters[i].perfil[lseq-l-1].nogaps;
    clusters[j].perfil[l].puntsintracluster=clusters[i].perfil[lseq-l-1].puntsintracluster;
  }
}

void escriure_sortida_cluster(int colnomsort,int cluster, int tipusconsensus, int alf, int longmer,int esc_concensus, int esc_alin,int numrepeats)
{
  int i, j, n,k ,l,nseq,v,midaalf;
  int **seqsalin;
  char c;
  int numseq,modul,modulsalt,m,salt;
  char consensus[MAXLONGSEQ],asterix[MAXLONGSEQ];
  char mer[MAXLONGMER],nom[MAXLONGNOM],aux[MAXLONGNOM],nomfamilia[MAXLONGNOM];
  double score;

  //printf("esc_alin %d esc_consensus %d num repeats %d\n",esc_alin,esc_concensus,numrepeats);
  switch (alf) {
  case 0: salt=1;midaalf=ALF_DNA;break;
  case 1: salt=1;midaalf =ALF_AMINO;
  case 2: salt=3;midaalf =ALF_CODO;break;
  }

  if (esc_alin){//escric aliniament 
    for(nseq = 0; nseq < clusters[cluster].num_seqs;nseq++){
      numseq=clusters[cluster].quines[nseq];
      k=0;
      while (k<colnomsort && clusters[numseq].nom_seq[k]!='\0' && clusters[numseq].nom_seq[k]!='\n'){
	c=clusters[numseq].nom_seq[k];
	printf("%c",c);
	consensus[k]=' ';
	asterix[k]=' ';
	k++;
      }
      while (k<colnomsort+3){
	printf("%c",' ');
	consensus[k]=' ';
	asterix[k]=' ';
	k++;
      }
      //escric primer
      n=matseqs[numseq][0];
      if (n!= -1)
          printf("%s",int2seq(mer,n,longmer,alf,1));//1 vol dir tot el mer
      else for (i=0;i<longmer*salt;i++) printf("-");
      //escric nla resta
      for (i=1;i<clusters[cluster].lcluster;i++){
          n=matseqs[numseq][i];
          //printf(" n=%d\n",n);
          if (n!= -1)
              printf("%s",int2seq(mer,n,longmer,alf,0));//0 vol dir nomes l'ultim
          else for (k=0;k<salt;k++) printf("-");
      }
      printf("\n");
      
    }
    
    get_asterix(asterix,colnomsort+3,cluster,midaalf,alf,longmer);
    printf("%s\n",asterix);
    printf("Consensus:\n");
    if (tipusconsensus == 0 || tipusconsensus == 2) {
      l= get_consensus(consensus,colnomsort+3,cluster,0,midaalf,alf,longmer);
      printf("%s\n",consensus);
    }
    if (tipusconsensus > 0) {
      l= get_consensus(consensus,colnomsort+3,cluster,1,midaalf,alf,longmer);
      printf("%s\n",consensus);
    }
    printf("\n");
  } 
  if (esc_concensus) {
    l= get_consensus(consensus,0,cluster,1,midaalf,alf,longmer);
    printf("%s\n",consensus);
    score = log(comb_nk(numrepeats,clusters[cluster].num_seqs))/log(2)+(clusters[cluster].num_seqs-1)*(clusters[cluster].lcluster-10)*clusters[cluster].puntuacio*(-log(4)/log(2));
    printf(" Num.repeats %d Similarity %f   seqs cluster=%d RE %f log (n sobre k) %f     %d log(1/4) %f\n",clusters[cluster].num_seqs,clusters[cluster].puntuacio,numrepeats,score,log(comb_nk(numrepeats,clusters[cluster].num_seqs)),clusters[cluster].lcluster-10,-log(4));
    printf("RE of rep. exp(%d)\n",(int)score);
    printf("--------------------------------------------\n");
  }
  l= get_consensus(consensus,0,cluster,1,midaalf,alf,longmer);
}

//reconstruir_nou_cluster ***********************************************/
//Amb un vector duns i dosos, i donades les seqüències anteriors, omple el cluster cluster1 amb les dades de l'alineament i la permutacio

void reconstruir_nou_cluster(char *resultat_cluster1, char *resultat_cluster2, tscluster *cluster1, tscluster cluster2, int len, int alf, float **matpesos)
{
  int i,j, k, l, m , n, numseq,seqscluster,longcluster,midaalf;
  
  int **seqsalin,*seq;
  int gapini,gapop,gapext,punts,ncar,nogaps;
  tscluster clusternou;
  
  switch (alf) {
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
  }  
  
  //printf("reservo memoria per llegir sequencies\n");
  longcluster=(*cluster1).lcluster+cluster2.lcluster;
  seqscluster=(*cluster1).num_seqs+cluster2.num_seqs;
  //printf("Reconstruir unio  clusters %d i %d de %d seqs i max long %d\n",cluster1,cluster2,seqscluster,longcluster);
  seq = (int *) malloc(longcluster * sizeof(int ));
  if (seq == NULL){printf("26:Out of memory\n"); exit(-1);}
  //reservo memoria per l'aliniament
  
  seqsalin = (int **) malloc(seqscluster * sizeof(int *));
  if (seqsalin == NULL){printf("27:Out of memory\n");exit(-1);}
  for (i = 0;i < seqscluster;i++){
    seqsalin[i] = (int *) malloc(longcluster * sizeof(int ));
    if (seqsalin[i] == NULL){printf("28:Out of memory\n");exit(-1);}
  }
  //printf("Cluster len = %d\n",len);
  //for (i=0;i<len;i++) printf(" %c ",resultat_cluster1[i]);
  
  /*cluster 1*/
  numseq = 0;
  //printf("%s\n",*(*cluster1).nomf);

  while (numseq < (*cluster1).num_seqs)
    {
      k=(*cluster1).quines[numseq];
      //printf("Llegeixo seq %d del cluster %d de long %ld\n",numseq,cluster1,*(*cluster1).lcluster);
      //printf("\n");

      l = 0;  //punter lectura array 
      m = 0;  //punter escriptura array desti
      while (l < len){
	if (resultat_cluster1[l] == '1'){  /*nucleotid*/
	  seqsalin[numseq][l] = matseqs[k][m];
	  m++;
	}
	else seqsalin[numseq][l] = -1;//gap
	//printf("%2d",seqsalin[numseq][l]);
	l++;
      }
      //printf("\n");
      numseq++;
    }
  //printf("\n");
  //  fclose(faux1); no el tanco perque cal actualutzar-lo
  //numseq segueix augmentant
  
/*cluster 2*/
 
  //for (i=0;i<len;i++) printf(" %c ",resultat_cluster2[i]);
  n=0;
  while (n < cluster2.num_seqs){
    k=cluster2.quines[n];
    l=0;
    m =0;
    while (l < len){
      if (resultat_cluster2[l] == '1'){  //nucleotid
	seqsalin[numseq][l] = matseqs[k][m];
          m++;//m=(m+1)%cluster2.lcluster;
      }
      else seqsalin[numseq][l] = -1; //gap
      //printf("%2d",seqsalin[numseq][l]);
      l++;
    }
    //printf("\n");
    n++;
    numseq++;
  }
  //actualitzem quines de cluster1
  for (i=0;i<cluster2.num_seqs;i++)
    (*cluster1).quines[(*cluster1).num_seqs+i]=cluster2.quines[i];
  //copio seqalin a matseqs  
  for (i=0;i<numseq;i++){
    k=(*cluster1).quines[i];
    for(j=0;j<len;j++){
      matseqs[k][j]=seqsalin[i][j];
      //printf("%2d ",seqsalin[i][j]);
    }
}
  //actualitzem numero de sequencies de cluster1
  (*cluster1).num_seqs = numseq;
  (*cluster1).lcluster=len;
  //printf("actualitzem dades perfil cluster1\n");
  inicialitzar_perfil_cluster((*cluster1).perfil,alf);//posa perfil a zero
  for (i=0;i<numseq;i++){
    ncar=0;
    gapini=1;
    gapop=gapext=0;
    for (j=0;j<len;j++){
      if (seqsalin[i][j]>-1) {
	(*cluster1).perfil[j].freq[seqsalin[i][j]]++;
	ncar++;
	gapext=0;
	if (ncar<clusters[(*cluster1).quines[i]].long_seq){
	  gapini=0; gapop=1;
	}
	else {
	  gapini=1;  gapop=0;
	}
      }
      else 
	if (gapini) (*cluster1).perfil[j].gap_ini++;
	else 
	  if (gapop) {
	    (*cluster1).perfil[j].gap_op++;
	    gapop=0;
	    gapext=1;
	  }
	  else (*cluster1).perfil[j].gap_ext++;
      //mostrar_info_cluster(*cluster1,alf);
    }
  }
  //printf("calculo els nogaps de cada posicio\n");
  for (j=0;j<(*cluster1).lcluster;j++){
    nogaps=0;
    for (i=0;i<midaalf;i++) nogaps +=(*cluster1).perfil[j].freq[i];
    (*cluster1).perfil[j].nogaps=nogaps;
  }
  //printf("enregistro els punts intra_cluster\n");
  i = 0;
  j = 0;
  k = 0;
  while (k < len){
  
    if ((resultat_cluster1[k] == '1') && (resultat_cluster2[k] == '1')){ 
      i++;j++;
    }
    else if ((resultat_cluster1[k] == '1') && (resultat_cluster2[k] == '2')) 
      i++;
    else if ((resultat_cluster1[k] == '2') && (resultat_cluster2[k] == '1')) 
      j++;
    (*cluster1).perfil[k].puntsintracluster=matriu_intra_cluster[i][j];
    //printf("cluster[%d].perfil[%d].Puntsintracluster = %f = matriuintracluster[%d,%d]\n",cluster1, k, matriu_intra_cluster[i][j], i,j);
    k++;
  }
    //mostrar_info_cluster(*cluster1,alf);
}

//donat un alineament determino el seu perfil
void determinar_perfil_desde_alineament(int ** seqalin,tscluster *cluster, int alf, float ** matpesos){
  int i,j,k,ini,fi,modeGO,punts,midaalf;
  switch (alf) {
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
   }
  inicialitzar_perfil_cluster((*cluster).perfil,alf);//posa perfil a zero
  for (i=0;i<(*cluster).num_seqs;i++){
    ini=0;
    while(seqalin[i][ini] == -1){
      (*cluster).perfil[ini].gap_ini++;
      ini++;
    }
    //ini apunta al primer no gap de l esquerra 
    fi=(*cluster).lcluster-1;
    while(seqalin[i][fi] == -1){
      (*cluster).perfil[fi].gap_ini++;
      fi--;
    }
    //fi apunta al primer no gap de la dreta
    modeGO=1;
    while (ini<=fi){
      if (seqalin[i][ini] == -1)
	if (modeGO) {
	  (*cluster).perfil[ini].gap_op++;
	  modeGO=0;
	}
	else{
	  (*cluster).perfil[ini].gap_ext++;
	}
      else {
	(*cluster).perfil[ini].freq[seqalin[i][ini]]++;
	(*cluster).perfil[ini].nogaps++;
	modeGO=1;
      }
      ini++;
    }
  }
      //printf("i ara calculo els punts intra cluster\n");
    
    for (i=0;i<(*cluster).lcluster;i++){
      punts=0;
        for (j=0; j<midaalf; j++)
            punts +=comb_2((*cluster).perfil[i].freq[j])*matpesos[j][j];
      for (j=0;j<midaalf;j++)
	    for(k=j+1;k<midaalf;k++)
            punts += (*cluster).perfil[i].freq[j]*(*cluster).perfil[i].freq[k]*matpesos[j][k];
       punts+= (*cluster).perfil[i].nogaps * (*cluster).perfil[i].gap_op *PUNTUACIO_FORAT_OP;
       punts += (*cluster).perfil[i].nogaps * (*cluster).perfil[i].gap_ext * PUNTUACIO_FORAT_EXT;
       punts += (*cluster).perfil[i].nogaps * (*cluster).perfil[i].gap_ini * PUNTUACIO_FORAT_INI;
       (*cluster).perfil[i].puntsintracluster=punts;
    }
    //mostrar_info_cluster((*cluster),alf);
}




//Mostra els valors dels clusters
void mostrar_info_cluster(tscluster cluster, int alf)
{
  int i,j,midaalf;

  switch (alf) {
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
  }
  
  printf("\nCLUSTER  %d\n",cluster.num_cluster);
  printf("nom=%s\n",cluster.nom_seq);
  printf("num_seqs=%d\n",cluster.num_seqs);
  printf("Sequencies: ");
  for (i=0;i<cluster.num_seqs;i++)  
    printf(" %d ",cluster.quines[i]);
  printf("\n");
  printf("longitud cluster=%ld\n",cluster.lcluster);
  //printf("Puntuacio=%f \n",cluster.puntuacio);
  printf("Perfil:\n");
  printf("Columna ini op ext nogaps puntuacio\n");
  for (i=0;i<cluster.lcluster;i++){
    printf("%d ",i);
    for (j=0;j<midaalf;j++)
      if (cluster.perfil[i].freq[j]!=0)
	printf("%d:%2.0f ",j,cluster.perfil[i].freq[j]);
    printf("gap:=%2.0f ",cluster.perfil[i].gap_ini);
    printf("%2.0f ",cluster.perfil[i].gap_op);
    printf("%2.0f ",cluster.perfil[i].gap_ext);
    printf("%2.0f ",cluster.perfil[i].nogaps);
    printf("%f \n",cluster.perfil[i].puntsintracluster);
  }
  printf("\n");
}


int  get_consensus(char* consensus, int colnomsort, int cluster,int tipusconsensus,int midaalf,int alf,int longmer)
{
  int i,j,mbase,nseqs,pos;
  float mval;
  char mer[MAXLONGMER];
  //mostrar_info_cluster(clusters[cluster],alf);  
  nseqs=clusters[cluster].num_seqs;
  //printf("Calculo consensus de %d sequencies\n",nseqs),
  pos=colnomsort;
  for (i=0;i<clusters[cluster].lcluster;i++){
    //mira si te + gaps que bases
    if (nseqs-clusters[cluster].perfil[i].nogaps<=(int)(nseqs/2)){
      //printf("buscar base maxima frequencia posicio %d midaalf %d\n",i,midaalf);
      mval=0;
      for (j=0;j<midaalf;j++){
	//printf("buscar base maxima frequencia posicio %d %f\n",i,clusters[cluster].perfil[i].freq[j]);
	if (mval<clusters[cluster].perfil[i].freq[j]){
	  mval= clusters[cluster].perfil[i].freq[j];
	  mbase=j;
	}
      }
      //printf("base:%d %f \n",mbase,mval);
      if (mval>=0.5 * nseqs) consensus[pos]= (mval>0.8*nseqs) ? toupper(*int2seq(mer,mbase,longmer,alf,1)) : tolower(*int2seq(mer,mbase,longmer,alf,1));
      else consensus[pos]='n';
      pos++;
    }
  }
  consensus[pos]='\0';
  return pos-colnomsort;
}
void get_asterix(char* asterix, int colnomsort, int cluster,int midaalf,int alf,int longmer)
{
  int i,j,mbase,nseqs,pos;
  float mval;
  nseqs=clusters[cluster].num_seqs;
  //reserva les bases inicials pel nom
  for (i=0;i<clusters[cluster].lcluster;i++){
    j=0;
    while (j<midaalf && clusters[cluster].perfil[i].freq[j] == 0) j++;
    if (clusters[cluster].perfil[i].freq[j] == nseqs) asterix[i+colnomsort]='*';
    else asterix[i+colnomsort]=' ';
  }
  asterix[i+colnomsort]='\0';
}
