#include "align.h"
#include "clusters.h"
#include "multiple.h"
#include "auxiliar.h"
#include "clus.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

/* alineament_multiple */
/*Funci que portar a terme laliniament mltiple de les seqncies a
//partir de la matriu de puntuacions dos a dos*/

void alineament_multiple(tscluster *clusters, int infoalign, int colnomsort, int parcial, float llindar,int minseqs,int metodecalculsim,int tipusconsensus,int alf,float **matpesos, int num_seqs, int longmer, int revseq,int esc_concensus,int esc_alin,int numrepeats)
{
  long *pos_seq;
  int *seq_cluster;
  int num_clusters;
  int i, j,k, l , continuar,len,midaalf,nclustersimprimir,*tclustersimprimir;
  
  float puntuacio,puntuacio_alineament,minimmatpunt,similaritat;
  int permut,*seq,cluster,cluster1,cluster2;
  FILE *faux;
  
  for(i = 0; i < MAXNUMSEQS; i++) cluster_equivalent[i] = i;
    //arreglo la matriu per anar descartant clusters
  minimmatpunt = calcular_minimmatpunt(num_seqs);
  for (i=0;i<num_seqs;i++) matriu_puntuacions[i][i]=minimmatpunt;
  //printf("Num total repeats %d i agafats  %d\n",numrepeats,num_seqs);
  num_clusters = num_seqs;
  //printf("\n Comencem l'alineament amb %d sequencies\n",num_clusters);
  continuar=1;
  while ((num_clusters > 1) && (continuar)){
    trobar_clusters_propers(&cluster1, &cluster2,&puntuacio,&permut,num_seqs);
    if ((clusters[cluster1].lcluster >= MAXLONGSEQ) || (clusters[cluster2].lcluster >= MAXLONGSEQ)){
      printf("Too long resulting alignment (>=MAXLONGSEQ)\n");
      //printf("cluster %d long %ld amb cluster %d long %ld\n",cluster1,clusters[cluster1].lcluster,cluster2,clusters[cluster2].lcluster);
      //exit(-1);
      continuar=0;
    }
    else{
      //printf("Clusters propers %d (%d seqs) (long %ld)i %d (%d seqs)(long %ld), puntuacio %f permut %d queden %d clusters\n",cluster1,clusters[cluster1].num_seqs,clusters[cluster1].lcluster,cluster2,clusters[cluster2].num_seqs,clusters[cluster2].lcluster,puntuacio,permut, num_clusters);
      continuar= (((puntuacio>=llindar) && (parcial)) || (!parcial));
      if (continuar){
          //si permut es 0 tambe passi per crear degut als gaps inicials
	//printf("num_seqs %d\n",clusters[cluster2].num_seqs);
	
	similitud_clusters( clusters[cluster1],clusters[cluster2], matpesos,alf,revseq,permut );

	//mostrar_matriu(matriu, clusters[i].long_seqs + 1, clusters[j].long_seqs + 1);
	//mostrar_matriu_cars(matriu_cami, clusters[i].long_seqs + 1, clusters[j].long_seqs + 1);
	puntuacio_alineament=0;
	alinea_clusters(clusters[cluster1].lcluster, clusters[cluster2].lcluster, resultat_cluster1, resultat_cluster2, &puntuacio_alineament, &len);
	//printf("%f %d %d %d %f\n",puntuacio_alineament,clusters[cluster1].num_seqs,clusters[cluster2].num_seqs,len,matpesos[0][0]);
	if (metodecalculsim == 1) similaritat = metodecalculsim1(puntuacio_alineament,clusters[cluster1].num_seqs+clusters[cluster2].num_seqs,len,matpesos[0][0]);
	else similaritat= puntuacio_alineament;
	clusters[cluster1].puntuacio=similaritat;
	reconstruir_nou_cluster(resultat_cluster1, resultat_cluster2, &clusters[cluster1], clusters[cluster2], len, alf,matpesos);
	//mostrar_info_cluster(clusters[cluster1],alf);
	recalcular_matriu(cluster1, cluster2,clusters[cluster1].num_seqs,clusters[cluster2].num_seqs,num_seqs,minimmatpunt);
	//printf("--2--matriu_puntuacio[%d][%d]=%f\n",1486,1487,matriu_puntuacions[1486][1487]);
	cluster_equivalent[cluster2]=cluster1;
	//escriure_sortida_cluster(nomfitxertaula,cluster1,nomfamilia,0,colnomsort,cluster1,tipusconsensus,alf,longmer);
	num_clusters--;
      }
    }
  }
  //Escriure sortida
  for (i=0;i<num_seqs;i++){
   if (cluster_equivalent[i] == i)
     escriure_sortida_cluster(colnomsort,i,tipusconsensus,alf,longmer,esc_concensus,esc_alin,numrepeats);
 }
}

/* trobar_clusters_propers **************************************************/
//Funci que busca les dues seqncies (o clusters) ms propers. Retorna el
//resultat com una fila (i) i una columna (j). Aquesta funci noms recorre
//la meitat de la matriu, ja que s simtrica, comenant pel (0,0)
void trobar_clusters_propers(int *i, int *j,float *puntuacio, int *permut, int num_seqs)
{
  int i_act, j_act, trobat;

  //printf("Busquem el primer\n");
  trobat = 0;
  for(i_act = 0; (i_act < num_seqs) && (trobat == 0); i_act++)
    if (cluster_equivalent[i_act] == i_act)
      for(j_act = i_act + 1; (j_act < num_seqs)  && (trobat == 0); j_act++)
	if (cluster_equivalent[j_act] == j_act){
	  //(matriu_puntuacions[i_act][j_act] != 0){
	  trobat = 1;
	  *(i) = i_act;
	  *(j) = j_act;
	}
  //printf("El primer es (%d, %d) amb score %f\n",*i,*j,matriu_puntuacions[*(i)][*(j)]);
  i_act = *(i);
  j_act = *(j);
  while (i_act < num_seqs){
    if (cluster_equivalent[i_act] == i_act){
      j_act = i_act + 1;
      while (j_act < num_seqs){
	if (cluster_equivalent[j_act] == j_act)
	  if (matriu_puntuacions[i_act][j_act] > matriu_puntuacions[*(i)][*(j)]){
	    *(i) = i_act;
	    *(j) = j_act;
	  }
	j_act++;
      }
    }
    i_act++;
  }
  *puntuacio=matriu_puntuacions[*(i)][*(j)];
  *permut=matriu_permutacions[*(i)][*(j)];
}

/* trobar_clusters_propers **************************************************/
//Funci que busca les dues seqncies (o clusters) ms propers. Retorna el
//resultat com una fila (i) i una columna (j). Aquesta funci noms recorre
//la meitat de la matriu, ja que s simtricacomenant pel final
void trobar_clusters_propers_inv(int *i, int *j,float *puntuacio, int *permut, int num_seqs)
{
  int i_act, j_act, trobat;

  //Busquem el primer
  trobat = 0;
  for(i_act = num_seqs-1; (i_act >=0) && (trobat == 0); i_act--)
    if (cluster_equivalent[i_act] == i_act)
      for(j_act = i_act - 1; (j_act >= 0)  && (trobat == 0); j_act--)
	if (cluster_equivalent[j_act] == j_act){
	  //(matriu_puntuacions[i_act][j_act] != 0){
	  trobat = 1;
	  *(i) = i_act;
	  *(j) = j_act;
	}

  i_act = *(i);
  j_act = *(j);
  while (i_act >= 0){
    if (cluster_equivalent[i_act] == i_act){
      j_act = i_act - 1;
      while (j_act >= 0){
	if (cluster_equivalent[j_act] == j_act)
	  if (matriu_puntuacions[i_act][j_act] > matriu_puntuacions[*(i)][*(j)]){
	    *(i) = i_act;
	    *(j) = j_act;
	  }
	j_act--;
      }
    }
    i_act--;
  }
  *puntuacio=matriu_puntuacions[*(i)][*(j)];
  *permut=matriu_permutacions[*(i)][*(j)];
}

/* similitud_clusters *******************************************************/
//Calcula la similitud entre dos clusters. A la matriu
//"matriu" hi ha les similituds entre tot prefix dels dos clusters.
void similitud_clusters(tscluster cluster1, tscluster  cluster2,float **matpesos, int alf, int revseq, int permut)
{
  int i = 0, j = 0,k,l,res,midaalf;
  float p_diag = 0, p_esq = 0, p_amunt = 0, max = 0;  //Puntuacions de les tres opcions possibles domplir una casella de la matriu
  char cami;
  int long_cluster1=cluster1.lcluster;
  int long_cluster2=cluster2.lcluster;
  
  switch (alf) {
  case 0: midaalf=ALF_DNA;break;
  case 1: midaalf=ALF_AMINO;break;
  case 2: midaalf=ALF_CODO;break;
  }
  //printf(" similitud entre clusters %d i %d\n",cluster1.num_cluster, cluster2.num_cluster);
  
  matriu[0][0] = 0;
  matriu_cami[0][0] = 'd';
  for (i = 1; i <= long_cluster1; i++)
    {
      //printf("puntsintracluster=%f ,nogaps
      //=%f\n",cluster1.perfil[i-1].puntsintracluster,cluster1.perfil[i-1].nogaps);
      p_amunt =cluster1.perfil[i-1].puntsintracluster;
      p_amunt +=cluster1.perfil[i-1].nogaps * cluster2.num_seqs * PUNTUACIO_FORAT_INI;
      
      matriu[i][0] = matriu[i-1][0] + p_amunt;
      matriu_cami[i][0] = 'a';
      matriu_intra_cluster[i][0]= p_amunt;
      //printf("pamunt=%f matriu[%d,0]=%f cami=%c matriuintracluster[%d,0]=%f\n",p_amunt,i,matriu[i][0],matriu_cami[i][0],i,matriu_intra_cluster[i][0]);
    }
  for (j = 1; j <= long_cluster2; j++)
    {
      //printf("puntsintracluster=%f ,nogaps =%f\n",clusters[cluster2].perfil[j-1].puntsintracluster,clusters[cluster2].perfil[j-1].nogaps);
      p_esq = cluster2.perfil[j-1].puntsintracluster;
      p_esq += cluster2.perfil[j-1].nogaps * cluster1.num_seqs * PUNTUACIO_FORAT_INI;
      //printf("%f %f %d %f\n", matriu[0][j-1], clusters[cluster2].perfil[j-1].nogaps, cluster1.num_seqs, PUNTUACIO_FORAT_INI);
      
      matriu[0][j]=matriu[0][j-1]+p_esq;
      matriu_cami[0][j] = 'e';
      matriu_intra_cluster[0][j]=p_esq; 
      //printf("i=0 j=%d %f %c %f\n",j,matriu[0][j],matriu_cami[0][j],matriu_intra_cluster[0][j]);
    }
  //printf("Inicialitzada matriu similitud\n");
  for (i = 1; i <= long_cluster1; i++)
    {      
      for (j = 1; j <= long_cluster2; j++)
	{
	  //printf("j= %d jpermut = %d\n",j,jpermut);
	  p_diag = 0;
	  p_esq = 0;
	  p_amunt = 0;
	  if (matriu_cami[i - 1][j - 1] == 'd')
	    {//Els gaps  no canvien
	      //Puntuaci inter-clusters
	      for (k=0;k<midaalf;k++)
		for (l=0;l<midaalf;l++)
		  p_diag += cluster1.perfil[i-1].freq[k]*cluster2.perfil[j-1].freq[l]*matpesos[k][l];
	      //printf(" d:p_diag= %f",p_diag);
	      p_diag += (cluster1.perfil[i-1].nogaps *cluster2.perfil[j-1].gap_op + cluster2.perfil[j-1].nogaps *cluster1.perfil[i-1].gap_op)*PUNTUACIO_FORAT_OP;
	      //printf(" gapop += %f",p_diag);
	      p_diag += (cluster1.perfil[i-1].nogaps *cluster2.perfil[j-1].gap_ext + cluster2.perfil[j-1].nogaps *cluster1.perfil[i-1].gap_ext)*PUNTUACIO_FORAT_EXT;
	      //printf(" gapext += %f",p_diag);
	      p_diag += (cluster1.perfil[i-1].nogaps *cluster2.perfil[j-1].gap_ini + cluster2.perfil[j-1].nogaps *cluster1.perfil[i-1].gap_ini)*PUNTUACIO_FORAT_INI;
	      //printf(" gapini += %f",p_diag);
	      //Puntuaci intra-clusters
	      p_diag+=cluster1.perfil[i-1].puntsintracluster+cluster2.perfil[j-1].puntsintracluster;
	      //printf(" gapintracluster += %f\n",p_diag);
	    }
	  else if (matriu_cami[i - 1][j - 1] == 'a'){
	    //Tots els forats del cluster 2 (dret) sn extension o extreme
	      //Puntuaci inter-clusters
	    for (k=0;k<midaalf;k++)
		for (l=0;l<midaalf;l++)
		  p_diag += cluster1.perfil[i-1].freq[k]* cluster2.perfil[j-1].freq[l]*matpesos[k][l];
	      p_diag += cluster1.perfil[i-1].gap_op* cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_OP;
	      p_diag += (cluster1.perfil[i-1].gap_ext * cluster2.perfil[j-1].nogaps + (cluster2.perfil[j-1].gap_op+cluster2.perfil[j-1].gap_ext)*cluster1.perfil[i-1].nogaps) * PUNTUACIO_FORAT_EXT;
	      p_diag += ( cluster1.perfil[i-1].gap_ini * cluster2.perfil[j-1].nogaps + cluster2.perfil[j-1].gap_ini * cluster1.perfil[i-1].nogaps )* PUNTUACIO_FORAT_INI;
	      //printf(" gaps += %f",p_diag);
	      //Puntuaci intra-clusters
	      p_diag += cluster1.perfil[i-1].puntsintracluster;
	     
	      p_diag += cluster2.perfil[j-1].puntsintracluster;
	      //printf(" gapintracluster += %f\n",p_diag);

	    }
	  else //la diagonal ve de l'esquerra
	    {//Tots els forats del cluster 1 (esquerre) sn extension o extreme
	      //Puntuaci inter-clusters
	      //printf("e:p_diag=");
	      for (k=0;k<midaalf;k++)
		for (l=0;l<midaalf;l++){
		  p_diag += cluster1.perfil[i-1].freq[k]* cluster2.perfil[j-1].freq[l]*matpesos[k][l];
		  //printf("  freq[%d]=%f freq[%d]=%f p_diag=%f",k,cluster1.perfil[i-1].freq[k],l,cluster2.perfil[j-1].freq[l],p_diag);
		}
	      //printf("\n %f", p_diag);
	      p_diag += cluster2.perfil[j-1].gap_op* cluster1.perfil[1-1].nogaps * PUNTUACIO_FORAT_OP;
	      
	      p_diag += (cluster2.perfil[j-1].gap_ext * cluster1.perfil[i-1].nogaps + (cluster1.perfil[i-1].gap_op+cluster1.perfil[1-1].gap_ext)*cluster2.perfil[j-1].nogaps) * PUNTUACIO_FORAT_EXT;
	      p_diag += ( cluster1.perfil[i-1].gap_ini * cluster2.perfil[j-1].nogaps + cluster2.perfil[j-1].gap_ini * cluster1.perfil[i-1].nogaps )* PUNTUACIO_FORAT_INI;
	      //printf(" gaps +=%f", p_diag);
	      //Puntuaci intra-clusters
	      p_diag += cluster1.perfil[i-1].puntsintracluster;
	     
	      p_diag += cluster2.perfil[j-1].puntsintracluster;
	      
	      //printf(" intracluster +=%f", p_diag);
	    }
	
	  if (j != long_cluster2)
	    {
	      if (matriu_cami[i - 1][j] == 'a')
		{
		  //Puntuaci inter-clusters
		  p_amunt = cluster1.perfil[i-1].nogaps * ( cluster2.perfil[j-1].nogaps+cluster2.perfil[j-1].gap_op+cluster2.perfil[j-1].gap_ext) * PUNTUACIO_FORAT_EXT;
		  p_amunt += cluster1.perfil[i-1].nogaps *  cluster2.perfil[j-1].gap_ini * PUNTUACIO_FORAT_INI;
		  //Puntuaci intra-cluster
		  p_amunt += cluster1.perfil[i-1].puntsintracluster;
		
		  
		}
	      else if (matriu_cami[i - 1][j] == 'd')
		{
		  //Puntuaci inter-clusters
		  
		  p_amunt= cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_OP;
		  p_amunt += cluster1.perfil[i-1].nogaps * ( cluster2.perfil[j-1].gap_op+  cluster2.perfil[j-1].gap_ext) * PUNTUACIO_FORAT_EXT;
		  p_amunt += cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].gap_ini * PUNTUACIO_FORAT_INI;
		  //Puntuaci intra-cluster
		  p_amunt += cluster1.perfil[i-1].puntsintracluster;
		 
		}
	      else
		{
		  //Puntuaci inter-clusters
		  
		  p_amunt = cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_OP;
		  p_amunt += cluster1.perfil[i-1].nogaps * ( cluster2.perfil[j-1].gap_op+  cluster2.perfil[j-1].gap_ext) * PUNTUACIO_FORAT_EXT;
		  p_amunt += cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].gap_ini * PUNTUACIO_FORAT_INI;
		  
		  //Puntuaci intra-cluster
		  p_amunt += cluster1.perfil[i-1].puntsintracluster;
		  
		}
	    }
	  else //j=Long_cluster2
	    {
		  //Puntuaci inter-cluster
		  p_amunt = cluster1.perfil[i-1].nogaps * cluster2.num_seqs *PUNTUACIO_FORAT_INI;
		  //Puntuaci intra-cluster
		  p_amunt += cluster1.perfil[i-1].puntsintracluster;
		 
	    }
	
	  if (i != long_cluster1)
	    {
	      if (matriu_cami[i][j - 1] == 'e')
		{
		  
		  //Puntuaci inter-cluster
		  p_esq  = cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_EXT;
		  p_esq  += (cluster1.perfil[i-1].gap_op+ cluster1.perfil[i-1].gap_ext) * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_EXT;
		  p_esq  += cluster1.perfil[i-1].gap_ini * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_INI;
		  //Puntuaci intra-cluster
		  p_esq += cluster2.perfil[j-1].puntsintracluster;
		 
		}
	      else if (matriu_cami[i][j - 1] == 'd')
		{
		  //Puntuaci inter-cluster
		  p_esq  = cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_OP;
		  p_esq  += ( cluster1.perfil[i-1].gap_op+ cluster1.perfil[i-1].gap_ext) * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_EXT;
		  p_esq  += cluster1.perfil[i-1].gap_ini * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_INI;
		  
		  //Puntuaci intra-cluster
		  p_esq += cluster2.perfil[j-1].puntsintracluster;
		}
	      else
		{
		  //Puntuaci inter-cluster
		  p_esq  = cluster1.perfil[i-1].nogaps * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_OP;
		  p_esq  += ( cluster1.perfil[i-1].gap_op+ cluster1.perfil[i-1].gap_ext) * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_EXT;
		  p_esq  += cluster1.perfil[i-1].gap_ini * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_INI;
		  
		  //Puntuaci intra-cluster
		  p_esq += cluster2.perfil[j-1].puntsintracluster;
		 
		}
	    }
	  else
	    {
		  //Puntuaci inter-cluster
		  p_esq  = cluster1.num_seqs * cluster2.perfil[j-1].nogaps * PUNTUACIO_FORAT_INI;
		  
		  //Puntuaci intra-cluster
		  p_esq += cluster2.perfil[j-1].puntsintracluster;
		 
	    }
	  //printf("bb\n");
	  res = posiciomaxim_3floats(matriu[i-1][j]+p_amunt,matriu[i-1][j-1]+p_diag, matriu[i][j-1]+p_esq,revseq,cluster1.num_cluster);
	  //if (cluster2 == 467) printf("[%d,%d]=a:%f  d:%f  e:%f escollida %d ---- a:%f  d:%f  e:%f\n",i,j,p_amunt,p_diag,p_esq,res,matriu[i-1][j]+p_amunt,matriu[i-1][j-1]+p_diag, matriu[i][j-1]+p_esq);
	  switch (res){
	  case 1:
	    matriu[i][j] = matriu[i-1][j]+p_amunt;
	    matriu_cami[i][j] = 'a';
	    matriu_intra_cluster[i][j]= p_amunt;
	    break;
	  case 2:
	    matriu[i][j] = matriu[i-1][j-1]+p_diag;
	    matriu_cami[i][j] = 'd';
	    matriu_intra_cluster[i][j]= p_diag;
	    break; 
	  case 3:
	    matriu[i][j] = matriu[i][j-1]+p_esq;
	    matriu_cami[i][j] = 'e';
	    matriu_intra_cluster[i][j]= p_esq;
	    break;  
	    //printf("matriu[%d][%d]=%lf %c\n",i,j,maxim,cami);
	  }
	  //printf("  i=%d j=%d %f %c %f \n",i,j,  matriu[i][j],matriu_cami[i][j],matriu_intra_cluster[i][j]);
	}
      //*puntuacio=max; //guarda la puntuacio del cluster
    }
}

/*Cada cluster esta representat per un vector indicant caracters i gaps*/
void alinea_clusters(int pos1, int pos2, char *res1, char *res2, float *puntuacio, int *len)
{
  //printf("%d %d \n",pos1,pos2);
  if ((pos1 == 0) && (pos2 == 0))
    {
      *len = 0;
    }
  else
    {
      switch(matriu_cami[pos1][pos2])
	{
	case 'a':
	  //	  printf("case a");
	  alinea_clusters(pos1 -1 , pos2, res1, res2, puntuacio, len);
	  res1[(*len)] = '1';  //1: hi ha un nucleotid en aquella posici
	  res2[(*len)] = '2';  //2: hi ha un gap en aquella posici
	  break;
	case 'd':
	  //printf("case d");
	  alinea_clusters(pos1 - 1, pos2 - 1, res1, res2, puntuacio, len);
	  res1[(*len)] = '1';
	  res2[(*len)] = '1';
	  break;
	case 'e':
	  //printf("case e");
	  alinea_clusters(pos1, pos2 - 1, res1, res2, puntuacio, len);
	  res1[(*len)] = '2';
	  res2[(*len)] = '1';
	  break;
	default:
	  //printf("case default\n");
	  break;
	}
      *puntuacio += matriu_intra_cluster[pos1][pos2];
      (*len)++;
            //printf("\n *puntuacio cluster = %f\n",*puntuacio);
    }
}

//recalcular_matriu ****************************************/
//Arregla la matriu, sabent que hem alineat els clusters "cluster1" i "cluster2"
void recalcular_matriu(int cluster1, int cluster2, int numseqs1, int numseqs2, int num_seqs, float minimmatpunt)
{
  int i;
  //printf("Recalculo fila i columna cluster1 pero no el seu complementari\n");
  for (i=0;i < num_seqs ; i++){
    if ((i != cluster1) && (cluster_equivalent[i]==i)  && (((cluster1%2==0) && (i!=cluster1+1)) || ((cluster1%2 == 1) && (i!=cluster1-1)))){
      matriu_puntuacions[cluster1][i] = (matriu_puntuacions[cluster1][i]*numseqs1 + matriu_puntuacions[cluster2][i]*numseqs2)/(numseqs1+numseqs2);
      matriu_puntuacions[i][cluster1] = matriu_puntuacions[cluster1][i];
      matriu_puntuacions[cluster2][i] = minimmatpunt;
      matriu_puntuacions[i][cluster2] = minimmatpunt;
    }
  }
  
  matriu_puntuacions[cluster1][cluster2] = minimmatpunt;
  matriu_puntuacions[cluster2][cluster1] = minimmatpunt;
}

float calcular_minimmatpunt(int numseqs){
  int i,j;
  float minim=0;
  
  minim=matriu_puntuacions[0][0];
  for (i=0;i<numseqs;i++)
    for (j=0;j<numseqs;j++)
      if (matriu_puntuacions[i][j] < minim) 
	minim=matriu_puntuacions[i][j];
  return (minim-1);
}

