#include <stdio.h>
#include "align.h"
#include "parells.h"
#include "clusters.h"
#include "auxiliar.h"
#include "clus.h"

void aliniament_local_per_parelles(int nseqs,float llindar, int alf,float ** matpesos,int colnomsort,int revseq){
  //printf("imprimeix les parelles majors que llindar\n");
  int s1,s2,lalin,lalin2;
  for (s1=0;s1<nseqs;s1++)
    for (s2=s1+1;s2<nseqs;s2++)
      if (matriu_puntuacions[s1][s2]>=llindar){
	similitud( s1,s2,matriu_permutacions[s1][s2],matpesos,&lalin,&lalin2,1,colnomsort,revseq);
	
      }
}


void calcul_sim_per_parelles(int numseqs,int revseq, int permutcirculars,int metodecalculsim,float **matpesos,int alf){
  int longseq1,longseq2;
  int s1,s2;
  float res;
  int permut;
  FILE *fsimentrada;

    s1 = 0;
  while (s1 < (numseqs - 1)){
    //mostrar_info_cluster(clusters[s1],alf);
    longseq1 = clusters[s1].long_seq;
    s2 = s1 + 1;
    while (s2 < numseqs) {
      //printf("Alinear %d amb %d\n",s1,s2);
      //mostrar_info_cluster(clusters[s2],alf);
      longseq2 = clusters[s2].long_seq;//dona_longitud_seq(k);
      //alguns calculs de les complementaries es poden simplificar
      if (s1%2==0 && s2==s1+1 && revseq){
	res = 0;
	permut = 0;
      }
      else{
	if(s1%2 == 1 && revseq){
	  if (s2%2 == 1) {
	    res=matriu_puntuacions[s1-1][s2-1];
	    permut =(longseq2-matriu_permutacions[s1-1][s2-1])%longseq2;
	    //printf("1 (puntuacio,permut[%d,%d])=(%f,%d)\n",s1,s2,res,permut);
	  }
	  else {
	    res=matriu_puntuacions[s1-1][s2+1];
	    //printf("4 %d %d \n",longseq2,matriu_permutacions[s1-1][s2+1]); 
	    permut=(longseq2-matriu_permutacions[s1-1][s2+1])%longseq2;
	    //printf("2 (puntuacio,permut)=(%f,%d)\n",res,permut);
	  }
	}
	else{
	  //printf("Calculo sim entre %d i %d\n",s1,s2);
	  //mostrar_info_cluster(clusters[s1],alf);
	  //mostrar_info_cluster(clusters[s2],alf);
	  //printf("\n\nValor aliniament per seq %d\n",j);
	  alineament_parells(s1,s2, permutcirculars, &res, &permut,metodecalculsim,matpesos);
	  
	  //printf("(puntuacio,permut)[%d][%d]=(%f,%d)\n",s1,s2,res,permut);
	}
      }
      matriu_puntuacions[s1][s2] = res;
      matriu_puntuacions[s2][s1] = res;
      matriu_permutacions[s1][s2] = permut;
      matriu_permutacions[s2][s1] = permut;
      //printf("puntuacio[%d][%d]=%f\n",s1,s2,res);
      s2++;
    }
    s1++;
  }
}


void alineament_parells(  int s1, int s2,int permutcirculars,float *maxres, int *maxpermut, int metodecalculsim, float **matpesos)

{
  //permutcirculars: si cal fer-les
  //retorna maxima puntuacio i la permutacio corresponent
	int k;
	float res;
	int lalin,lalin2;
	long long_seq1,long_seq2;
	long_seq1=clusters[s1].long_seq;
	long_seq2=clusters[s2].long_seq;
	res = similitud( s1, s2,0,matpesos,&lalin,&lalin2,0,0,0); /*Omplim la matriu de similituds sense permutar*/
	if (metodecalculsim == 1) res=metodecalculsim1(res,2,lalin,matpesos[0][0]);
	else if (metodecalculsim == 2) res=metodecalculsim1(res,2,lalin2,matpesos[0][0]);
	//printf("res %f permut %d \n",res,0);
	*maxres=res;
        *maxpermut=0;
	//printf("alin optim:res %f permut %d ",res,k); 
        if (permutcirculars) //k es la permutacio circular
          for (k=1;k<minim(long_seq1,long_seq2);k++) {
            res = similitud( s1, s2,k,matpesos,&lalin,&lalin2,0,0,0);
	    if (metodecalculsim == 1) res=metodecalculsim1(res,2,lalin,matpesos[0][0]);
	    else if (metodecalculsim == 2) res=metodecalculsim1(res,2,lalin2,matpesos[0][0]);
	    
	    //printf("lseq1 %ld lseq2 %ld res %f permut %d lalin %d lalin2 %d \n",long_seq1,long_seq2,res,k,lalin,lalin2);
            if (res>*maxres){*maxres=res;*maxpermut=k;}
          }
}


/* similitud *************************************************************/
//Calcula la similitud entre les seqncies "seq1" i "seq2" amb permut permutacio circular. A la matriu
//"matriu" hi ha les similituds entre tot prefix de les dues seqncies.
//lalin te la longitud de l aliniement
//lalin2 te la longitud de l aliniament sense els gaps extrems de la mes curta
//imprimir indica si cal imprimir l'alineament
float similitud( int s1, int s2, int permut,float **matpesos, int *lalin,int *lalin2,int imprimir,int colnomsort,int revseq)
{
  int i, j, res;
  float p_amunt, p_esq , p_diag;
  long long_seq1,long_seq2;
  
  seq1=matseqs[s1];
  long_seq1=clusters[s1].long_seq;
  long_seq2=clusters[s2].long_seq;

  //printf("Entro a similitud de parelles\n");
  //permuto sequencia portant la darrera base cap al principi k cops
  //printf("\n2:%s\n",cpseq2);
  for (i=0;i<long_seq2-permut;i++) seq2[i+permut]=matseqs[s2][i];
  for (i=0;i<permut;i++) seq2[i]=matseqs[s2][long_seq2-permut+i];
  //printf("Inicialitzo\n");
  for (i = 0; i <= long_seq1; i++){
    matriu[i][0] = i * PUNTUACIO_FORAT_INI;
    matriu_cami[i][0] = 'a';
    //matriu_intra_cluster[i][0]=0;//PUNTUACIO_FORAT_INI;
    //printf("matriu[%d][0]=%lf %c\n",i,matriu[i][0],matriu_cami[i][0]);
  } 
  
  for (j = 0; j <= long_seq2; j++){
    matriu[0][j] = j * PUNTUACIO_FORAT_INI; 
    matriu_cami[0][j] = 'e';
    //matriu_intra_cluster[0][j]=0://PUNTUACIO_FORAT_INI;
    //printf("matriu[0][%d]=%lf %c\n",j,matriu[0][j],matriu_cami[0][j]);
  } 
  matriu_cami[0][0]='d';
  //matriu_intra_cluster[0][0]=0;
  //printf("calcul similaritat\n");
  for (i = 1; i <= long_seq1; i++){
    for (j = 1; j <= long_seq2; j++){
      if (j != long_seq2){
	if (matriu_cami[i - 1][j] == 'a')
	  p_amunt = PUNTUACIO_FORAT_EXT;
	else
	  p_amunt = PUNTUACIO_FORAT_OP;
      }
      else
	p_amunt = PUNTUACIO_FORAT_INI;
			
      if (i != long_seq1){
	if (matriu_cami[i][j - 1] == 'e')
	  p_esq = PUNTUACIO_FORAT_EXT;
	else
	  p_esq = PUNTUACIO_FORAT_OP;
      }
      else
	p_esq = PUNTUACIO_FORAT_INI;
      p_diag=matpesos[seq1[i-1]][seq2[j-1]];
      //printf("p_diag=%f %f\n",p_diag,matriu[i-1][j-1]);
      //printf("seq1[i-1]=%d [seq2[j-1]=%d\n",seq1[i-1],seq2[j-1]);
      //printf("pamunt=%f  pdiag=%f pesq=%f\n",p_amunt,p_diag, p_esq);
      p_amunt=matriu[i-1][j]+p_amunt;
      p_diag=matriu[i-1][j-1]+p_diag;
      p_esq=matriu[i][j-1]+p_esq;
      //printf("pamunt=%f  pdiag=%f pesq=%f\n",p_amunt,p_diag, p_esq);
      res = posiciomaxim_3floats(p_amunt,p_diag, p_esq,0,0);
      switch (res){
      case 1:
	matriu[i][j] = p_amunt;
	matriu_cami[i][j] = 'a';
	//matriu_intra_cluster[i][j]= p_amunt;
	break;
      case 2:
       matriu[i][j] = p_diag;
	matriu_cami[i][j] = 'd';
	//matriu_intra_cluster[i][j]= p_diag;
	break; 
      case 3:
	matriu[i][j] = p_esq;
	matriu_cami[i][j] = 'e';
	//matriu_intra_cluster[i][j]= p_esq;
	break;  
	
      }
      //printf("matriu[%d][%d]=%f %c el maxim entre %f %f %f\n",i,j,matriu[i][j],matriu_cami[i][j],p_amunt,p_diag,p_esq);
    }
  }
  //calculo la longitud de l alinieament
  i=long_seq1;
  j=long_seq2;
  *lalin=0;//longitud de l'aliniament
  *lalin2=0;//longitud de l'aliniament treient els gaps ini de seq1
  while (i>0 && j>0){
    switch (matriu_cami[i][j]){
    case 'a': i--;break;
    case 'd': i--;j--;break;
    case 'e': j--;break;
    }
    if (i !=long_seq1) (*lalin2)++;
    (*lalin)++;
    //printf("cami[%d][%d] %c lalin %d lalin2 %d \n",i,j,matriu_cami[i][j],*lalin,*lalin2);
  }
  *lalin = *lalin+i+j;
  *lalin2 =*lalin2+i;
  //printf("res %f \n",matriu[long_seq1][long_seq2]);
  if (imprimir && (!revseq || (revseq && s1%2==0)))
    imprimir_per_parelles(s1,s2,long_seq1,long_seq2,seq1,seq2,*lalin,colnomsort);
  return(matriu[long_seq1][long_seq2]);
}

void imprimir_per_parelles(int s1,int s2,int long_seq1,int long_seq2,int *seq1,int *seq2,int lalin,int colnomsort){
  //matriu_cami te la matriu dinamica
  //printf("%d %d %d %d %d %d\n",s1,s2,long_seq1,long_seq2,lalin,colnomsort);
  char *nom1,*nom2;
  char c, *alinseq1,*alinseq2;
  int i,j,pos;
  //printf("Copio el nom\n");
  nom1 = (char *) malloc (MAXLONGNOM *sizeof(char));
  if (nom1 == NULL){printf("Out of memory nom1:parelles\n");exit(-1);}
  nom2 = (char *) malloc (MAXLONGNOM *sizeof(char));
  if (nom2 == NULL){printf("Out of memory nom2:parelles\n");exit(-1);}
  for(i=0;i<colnomsort;i++){
    nom1[i]=clusters[s1].nom_seq[i];
    nom2[i]=clusters[s2].nom_seq[i];
  }
for(i=colnomsort;i<colnomsort+3;i++){
    nom1[i]=' ';
    nom2[i]=' ';
  }
//for (i=0;i<long_seq1;i++) printf("%c",int2DNA(seq1[i]));
 nom1[colnomsort+3]='\0';
 nom2[colnomsort+3]='\0';
 //printf("faig alineament\n");
  alinseq1 = (char *) malloc (MAXLONGSEQ *sizeof(char));
  if (alinseq1 == NULL){printf("Out of memory alinseq1:parelles\n");exit(-1);}
  alinseq2 = (char *) malloc (MAXLONGSEQ *sizeof(char));
  if (alinseq2 == NULL){printf("Out of memory alinseq2:parelles\n");exit(-1);}
  pos=lalin-1;
  i=long_seq1;
  j=long_seq2;
  while (i>=0 && j>=0){
    c=(matriu_cami[i][j]);
    if (c=='a'){
      alinseq1[pos]=int2DNA(seq1[i-1]) ;
      alinseq2[pos]='-';
      i--;
    }
    else if (c=='d'){
      alinseq1[pos]=int2DNA(seq1[i-1]);
      alinseq2[pos]=int2DNA(seq2[j-1]);
      i--;j--;
    }
    else{
      alinseq1[pos]='-';
      alinseq2[pos]=int2DNA(seq2[j-1]);
      j--;
    }
    //printf ("%d %c %c --",pos,alinseq1[pos],alinseq2[pos]);
    pos--;
  }
  
  printf("%-40s%s\n",nom1,alinseq1);
  printf("%-40s%s\n",nom2,alinseq2);
  printf("\n");
}
      
